unit form_main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, RTTIGrids, RTTICtrls, TANavigation, TAGraph,
  TASources, TATools, TAChartListbox, TALegendPanel, TAChartExtentLink,
  PrintersDlgs, LR_Class, LR_DSet, Forms, Controls, Graphics, Dialogs, ComCtrls,
  Menus, ActnList, DbCtrls, DBGrids, BarChart, StdCtrls, ValEdit, ExtCtrls,
  Grids, Calendar, EditBtn, Dbf, DB, sqldb, types, form_askdelete_bloodvals,
  libdlgform_print, Printers, IniPropStorage, Math, tools_stringTable,
  form_morsett, form_about;

type

  { Tform_main2 }

  Tform_main2 = class(TForm)
    action_about: TAction;
    action_enter_informations: TAction;
    action_page_dialog: TAction;
    action_print: TAction;
    action_print_setup: TAction;
    action_close: TAction;
    action_db_save_as: TAction;
    action_db_save: TAction;
    action_db_open: TAction;
    action_db_new: TAction;
    BarChart1: TBarChart;
    button_bloodvals_delete: TButton;
    button_bloodvals_apply: TButton;
    Chart1: TChart;
    edit_bloodvals__date1: TCalendar;
    DBGrid_bloodvals: TDBGrid;
    DBFieldValueEditor: TDBEdit;
    edit_bloodvals__datetime1: TDBEdit;
    bloodvals__overview__days: TStringGrid;
    edit_bloodvals__props: TStringGrid;
    IniPropStorage1: TIniPropStorage;
    Memo2: TMemo;
    menu_about: TMenuItem;
    menu_enter_informations: TMenuItem;
    Panel13: TPanel;
    Panel14: TPanel;
    Panel15: TPanel;
    reportPrintData_bloodValues: TfrUserDataset;
    reportPrintData_bloodProps: TfrUserDataset;
    printReport: TfrReport;
    Label1: TLabel;
    Label3: TLabel;
    main_actions: TActionList;
    DSbloodvals: TDatasource;
    DBAbloodvals: TDbf;
    main_menu: TMainMenu;
    MainTabPageControl: TPageControl;
    main_tab_view_entrys: TTabSheet;
    Memo1: TMemo;
    menu_main_page_dialog: TMenuItem;
    menu_main_print_setup: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    menu_main_print: TMenuItem;
    menu_main_close: TMenuItem;
    menu_main_db_load: TMenuItem;
    menu_main_db_saveas: TMenuItem;
    menu_main_db_save: TMenuItem;
    menu_main_db_new: TMenuItem;
    menu_main: TMenuItem;
    DIAG_OPENDB: TOpenDialog;
    DIAG_SAVEDB: TSaveDialog;
    main_tab_overview_pagecontrol: TPageControl;
    PageSetupDialog1: TPageSetupDialog;
    Panel1: TPanel;
    infoPanel_noDB: TPanel;
    Panel10: TPanel;
    Panel11: TPanel;
    Panel12: TPanel;
    infoPanel_overview: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel5: TPanel;
    Panel6: TPanel;
    main_tab_edit_entry: TTabSheet;
    main_tab_stats1: TTabSheet;
    Panel9: TPanel;
    main_tab_infos_bloodvals: TTabSheet;
    baseinfos_bloodvals_stringGrid: TStringGrid;
    main_tab_overview_days: TTabSheet;
    PrintDialog1: TPrintDialog;
    PrinterSetupDialog1: TPrinterSetupDialog;
    main_tab_overview_createInfo: TTabSheet;
    procedure action_aboutExecute(Sender: TObject);
    procedure action_closeExecute(Sender: TObject);
    procedure action_db_newExecute(Sender: TObject);
    procedure action_db_openExecute(Sender: TObject);
    procedure action_db_saveExecute(Sender: TObject);
    procedure action_db_save_asExecute(Sender: TObject);
    procedure action_enter_informationsExecute(Sender: TObject);
    procedure action_page_dialogExecute(Sender: TObject);
    procedure action_print_alternative;
    procedure action_printExecute(Sender: TObject);
    procedure action_print_setupExecute(Sender: TObject);
    procedure bloodvals__overview__daysClick(Sender: TObject);
    procedure bloodvals__overview__daysDblClick(Sender: TObject);
    procedure bloodvals__overview__daysResize(Sender: TObject);
    procedure bloodvals__overview__daysSelectCell(Sender: TObject; aCol,
      aRow: Integer; var CanSelect: Boolean);
    procedure bloodvals__overview__daysSelection(Sender: TObject; aCol,
      aRow: Integer);
    procedure button_bloodvals_applyClick(Sender: TObject);
    procedure button_bloodvals_deleteClick(Sender: TObject);
    procedure DBGrid_bloodvalsCellClick(Column: TColumn);
    procedure DBGrid_bloodvalsDblClick(Sender: TObject);
    procedure DSbloodvalsUpdateData(Sender: TObject);
    procedure edit_bloodvals__date1Change(Sender: TObject);
    procedure edit_bloodvals__propsClick(Sender: TObject);
    procedure edit_bloodvals__propsResize(Sender: TObject);
    procedure edit_bloodvals__propsSelectEditor(Sender: TObject; aCol,
      aRow: Integer; var Editor: TWinControl);
    procedure edit_bloodvals__propsSetEditText(Sender: TObject; ACol,
      ARow: Integer; const Value: string);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure HaveDataNotEmpty(Sender: TObject);
    procedure InEditMode(Sender: TObject);
    procedure main_actionsExecute(AAction: TBasicAction; var Handled: Boolean);
    procedure baseinfos_bloodvals_stringGridResize(Sender: TObject);
    procedure main_tab_edit_entryContextPopup(Sender: TObject;
      MousePos: TPoint; var Handled: Boolean);
    procedure main_tab_edit_entryEnter(Sender: TObject);
    procedure main_tab_edit_entryShow(Sender: TObject);
    procedure main_tab_overview_daysShow(Sender: TObject);
    procedure main_tab_stats1ContextPopup(Sender: TObject; MousePos: TPoint;
      var Handled: Boolean);
    procedure main_tab_view_entrysContextPopup(Sender: TObject;
      MousePos: TPoint; var Handled: Boolean);
    procedure main_tab_view_entrysShow(Sender: TObject);
    procedure Memo1Change(Sender: TObject);
    procedure menu_main_page_dialogExecute(Sender: TObject);
    procedure menu_main_printClick(Sender: TObject);
    procedure menu_main_print_setupExecute(Sender: TObject);
    procedure printReportBeginPage(pgNo: Integer);
    procedure printReportEnterRect(Memo: TStringList; View: TfrView);
    procedure printReportGetValue(const ParName: String; var ParValue: Variant);
    procedure printReportPrintColumn(ColNo: Integer; var wWidth: Integer);
    procedure reportPrintData_bloodPropsCheckEOF(Sender: TObject;
      var Eof: Boolean);
    procedure reportPrintData_bloodPropsFirst(Sender: TObject);
    procedure reportPrintData_bloodPropsNext(Sender: TObject);
    procedure reportPrintData_bloodValuesCheckEOF(Sender: TObject;
      var Eof: Boolean);
    procedure reportPrintData_bloodValuesFirst(Sender: TObject);
    procedure reportPrintData_bloodValuesNext(Sender: TObject);
    procedure ValueListEditor1Click(Sender: TObject);
  private
    procedure tools_db_getActive(daSe: TDataSet; idStr: string);
    procedure tools_db_setActive(daSe: TDataSet; idStr: string; idVal: Integer);
    procedure tools_db_getUniqueId(daSe: TDataSet; idStr: string);
    procedure tools_db_getCount(daSe: TDataSet);
    procedure CreateTable_bloodvals(AFileName : String);
    procedure OpenTable_bloodvals(AFileName: String);
    procedure CloseTable_bloodvals;
    procedure updateOverviews;
    function printView_print(requiredInfo: Integer; pageObjType: String; pageIndex: Integer; dataSrc: TDatasource): String;
    var
       flag_doEdit: boolean;
       flag_doInitEdit: boolean;
       flag_inited: boolean;
       flag_isWork_cellSelect: boolean;
       flag_actualizeDataViews: boolean;

       tools_result_string: String;
       tools_result_LongInt: LongInt;
       tools_result_integer: Integer;

       database_fileName: String;
  public
    reportPrintData_row: integer;
    reportPrintData_col: integer;
    reportPrintData_colsPerPage: integer;
    reportPrintData_colInPage: integer;
    reportPrintData_dataRow: integer;
    reportPrintData_dataCol: integer;
    reportPrintData_headerRow: integer;
    reportPrintData_headerCol: integer;
    reportPrintData_doNotForgetheaderCols: Integer;
    reportPrintData_work: boolean;
    reportPrintData_activePage: integer;
    reportPrintData_newActivePage: integer;
    reportPrintData_manageHeader_row: boolean;
    reportPrintData_manageHeader_col: boolean;
    reportPrintData_managePages: integer;
    reportPrintData_customDataList: TStringList;

    { public declarations }
  end; 

var
  form_main2: Tform_main2;
  form_askDeleteBloodVals: Tform_askDeleteBloodVals;
  dlgForm_print: Tform_dlg_print;
  dlgForm_userSettings: Tform_moresettings;
  dlgForm_aboutsoft: Tform_aboutsoft;

implementation

{$R *.lfm}

resourcestring
  SSaveData = 'Es sind ungespeicherte Änderungen an Daten vorhanden. Jetzt speichern?';

procedure Tform_main2.action_db_newExecute(Sender: TObject);
begin
  With DIAG_SAVEDB do
    If Execute then
      CreateTable_bloodvals(FileName);
end;

procedure Tform_main2.CreateTable_bloodvals(AFileName : String);
begin
  With DBAbloodvals do
    begin
    Close;
    with FieldDefs do
      begin
      Clear;
      Add('id',ftInteger,30);
      Add('datetime1',ftString,30);
      Add('datetime2',ftString,30);
      Add('datetime3',ftString,30);
      Add('datetime4',ftString,30);
      Add('time1',ftString,30);
      Add('time2',ftString,30);
      Add('time3',ftString,30);
      Add('time4',ftString,30);
      Add('data1',ftString,30);
      Add('data2',ftString,30);
      Add('data3',ftString,30);
      Add('data4',ftString,30);
      Add('data5',ftString,30);
      Add('data6',ftString,30);
      Add('data7',ftString,30);
      Add('data8',ftString,30);
      Add('data9',ftString,30);
      Add('data10',ftString,30);
      Add('data11',ftString,30);
      Add('data12',ftString,30);
      Add('data13',ftString,30);
      Add('data14',ftString,30);
      Add('data15',ftString,30);
      Add('data16',ftString,30);
      Add('data17',ftString,30);
      Add('data18',ftString,30);
      Add('data19',ftString,30);
      Add('data20',ftString,30);
      Add('data21',ftString,30);
      Add('data22',ftString,30);
      Add('data23',ftString,30);
      Add('data24',ftString,30);
      Add('data25',ftString,30);
      Add('data26',ftString,30);
      Add('data27',ftString,30);
      Add('data28',ftString,30);
      Add('data29',ftString,30);
      Add('data30',ftString,30);
      Add('data31',ftString,30);
      Add('data32',ftString,30);
      Add('data33',ftString,30);
      Add('data34',ftString,30);
      Add('data35',ftString,30);
      Add('data36',ftString,30);
      Add('data37',ftString,30);
      Add('data38',ftString,30);
      Add('data39',ftString,30);
      Add('data40',ftString,30);
      Add('data41',ftString,30);
      Add('data42',ftString,30);
      Add('data43',ftString,30);
      Add('data44',ftString,30);
      Add('data45',ftString,30);
      Add('data46',ftString,30);
      Add('data47',ftString,30);
      Add('data48',ftString,30);
      Add('data49',ftString,30);
      Add('data50',ftString,30);
      Add('data51',ftString,30);
      Add('data52',ftString,30);
      Add('data53',ftString,30);
      Add('data54',ftString,30);
      Add('data55',ftString,30);
      Add('data56',ftString,30);
      Add('data57',ftString,30);
      Add('data58',ftString,30);
      Add('data59',ftString,30);
      Add('data60',ftString,30);
      Add('data61',ftString,30);
      Add('data62',ftString,30);
      Add('data63',ftString,30);
      Add('data64',ftString,30);
      Add('data65',ftString,30);
      Add('data66',ftString,30);
      Add('data67',ftString,30);
      Add('data68',ftString,30);
      Add('data69',ftString,30);
      Add('data70',ftString,30);
      Add('data71',ftString,30);
      Add('data72',ftString,30);
      Add('data73',ftString,30);
      Add('data74',ftString,30);
      Add('data75',ftString,30);
      Add('data76',ftString,30);
      Add('data77',ftString,30);
      Add('data78',ftString,30);
      Add('data79',ftString,30);
      Add('data80',ftString,30);
      Add('data81',ftString,30);
      Add('data82',ftString,30);
      Add('data83',ftString,30);
      Add('data84',ftString,30);
      Add('data85',ftString,30);
      Add('data86',ftString,30);
      Add('data87',ftString,30);
      Add('data88',ftString,30);
      Add('data89',ftString,30);
      Add('data90',ftString,30);
      Add('data91',ftString,30);
      Add('data92',ftString,30);
      Add('data93',ftString,30);
      Add('data94',ftString,30);
      Add('data95',ftString,30);
      Add('data96',ftString,30);
      Add('data97',ftString,30);
      Add('data98',ftString,30);
      Add('data99',ftString,30);
      Add('data100',ftString,30);
      Add('data101',ftString,30);
      Add('data102',ftString,30);
      Add('data103',ftString,30);
      Add('data104',ftString,30);
      Add('data105',ftString,30);
      Add('data106',ftString,30);
      Add('data107',ftString,30);
      Add('data108',ftString,30);
      Add('data109',ftString,30);
      Add('data110',ftString,30);
      Add('data111',ftString,30);
      Add('data112',ftString,30);
      Add('data113',ftString,30);
      Add('data114',ftString,30);
      Add('data115',ftString,30);
      Add('data116',ftString,30);
      Add('data117',ftString,30);
      Add('data118',ftString,30);
      Add('data119',ftString,30);
      Add('data120',ftString,30);
      Add('data121',ftString,30);
      Add('data122',ftString,30);
      Add('data123',ftString,30);
      Add('data124',ftString,30);
      Add('data125',ftString,30);
      Add('data126',ftString,30);
      Add('data127',ftString,30);
      Add('data128',ftString,30);
      Add('data129',ftString,30);
      Add('data130',ftString,30);
      Add('data131',ftString,30);
      Add('data132',ftString,30);
      Add('data133',ftString,30);
      Add('data134',ftString,30);
      Add('data135',ftString,30);
      Add('data136',ftString,30);
      Add('data137',ftString,30);
      Add('data138',ftString,30);
      Add('data139',ftString,30);
      Add('data140',ftString,30);
      Add('data141',ftString,30);
      Add('data142',ftString,30);
      Add('data143',ftString,30);
      Add('data144',ftString,30);
      Add('data145',ftString,30);
      Add('data146',ftString,30);
      Add('data147',ftString,30);
      Add('data148',ftString,30);
      Add('data149',ftString,30);
      Add('data150',ftString,30);
      Add('data151',ftString,30);
      Add('data152',ftString,30);
      Add('data153',ftString,30);
      Add('data154',ftString,30);
      Add('data155',ftString,30);
      Add('data156',ftString,30);
      Add('data157',ftString,30);
      Add('data158',ftString,30);
      Add('data159',ftString,30);
      Add('data160',ftString,30);
      Add('data161',ftString,30);
      Add('data162',ftString,30);
      Add('data163',ftString,30);
      Add('data164',ftString,30);
      Add('data165',ftString,30);
      Add('data166',ftString,30);
      Add('data167',ftString,30);
      Add('data168',ftString,30);
      Add('data169',ftString,30);
      Add('data170',ftString,30);
      Add('data171',ftString,30);
      Add('data172',ftString,30);
      Add('data173',ftString,30);
      Add('data174',ftString,30);
      Add('data175',ftString,30);
      Add('data176',ftString,30);
      Add('data177',ftString,30);
      Add('data178',ftString,30);
      Add('data179',ftString,30);
      Add('data180',ftString,30);
      Add('data181',ftString,30);
      Add('data182',ftString,30);
      Add('data183',ftString,30);
      Add('data184',ftString,30);
      Add('data185',ftString,30);
      Add('data186',ftString,30);
      Add('data187',ftString,30);
      Add('data188',ftString,30);
      Add('data189',ftString,30);
      Add('data190',ftString,30);
      Add('data191',ftString,30);
      Add('data192',ftString,30);
      Add('data193',ftString,30);
      Add('data194',ftString,30);
      Add('data195',ftString,30);
      Add('data196',ftString,30);
      Add('data197',ftString,30);
      Add('data198',ftString,30);
      Add('data199',ftString,30);
      end;
    TableName:=AFileName;
    CreateTable;
    Exclusive := true;
    Open;
    AddIndex('id', 'id', []);

    database_fileName := AFileName;
    infoPanel_noDB.Hide;
    action_print.Enabled := true;
    infoPanel_overview.Show;
    MainTabPageControl.CustomPage(1).TabVisible:=true;
    MainTabPageControl.CustomPage(3).TabVisible:=true;
    MainTabPageControl.CustomPage(0).Show;
    IniPropStorage1.IniFileName := DBAbloodvals.TableName + '.ini';
    IniPropStorage1.IniSection := 'userdata';
    IniPropStorage1.Active := true;
    menu_enter_informations.Visible := true;
    flag_actualizeDataViews := true;
    updateOverviews;
    action_enter_informations.Execute;
    end;
end;

procedure Tform_main2.OpenTable_bloodvals(AFileName : String);
begin
  With DBAbloodvals do
    begin
    Close;
    TableName:=AFileName;
    Open;
    infoPanel_noDB.Hide;
    action_print.Enabled := true;
    infoPanel_overview.Show;
    database_fileName := AFileName;
    MainTabPageControl.CustomPage(1).TabVisible:=true;
    MainTabPageControl.CustomPage(3).TabVisible:=true;
    MainTabPageControl.CustomPage(0).Show;
    menu_enter_informations.Visible := true;
    flag_actualizeDataViews := true;
    updateOverviews;
    end;
end;

procedure Tform_main2.CloseTable_bloodvals;
begin
  DBAbloodvals.Close;
end;


procedure Tform_main2.updateOverviews;
  var i : LongInt;
  var v : Integer;
  var z : LongInt;
  var ts : string;
  var ts2 : string;
  var dsCou : Integer;
begin
  tools_db_getCount(DBGrid_bloodvals.DataSource.DataSet);
  dsCou := tools_result_integer;

  if dsCou = 0 then
  begin
    for i := 0 to main_tab_overview_pagecontrol.PageCount - 1 do
    begin
      main_tab_overview_pagecontrol.CustomPage(i).TabVisible:=false;
    end;
    main_tab_overview_pagecontrol.CustomPage(0).Show;
  end;

  if main_tab_overview_pagecontrol.CustomPage(0).IsVisible then begin
    if dsCou > 0 then
    begin
      for i := 0 to main_tab_overview_pagecontrol.PageCount - 1 do
      begin
        main_tab_overview_pagecontrol.CustomPage(i).TabVisible:=true;
      end;
      main_tab_overview_pagecontrol.CustomPage(0).TabVisible:=false;
      main_tab_overview_pagecontrol.CustomPage(1).Show;
    end;
  end;

  if flag_actualizeDataViews = true then
  begin
    flag_actualizeDataViews := false;

    if dsCou > 0 then
    begin
      bloodvals__overview__days.ColCount := bloodvals__overview__days.FixedCols + LongInt(dsCou);
      bloodvals__overview__days.RowCount := baseinfos_bloodvals_stringGrid.RowCount + LongInt(1);
      for i := 1 to baseinfos_bloodvals_stringGrid.RowCount - 1 do
      begin
          bloodvals__overview__days.Cells[0, i + 1] := baseinfos_bloodvals_stringGrid.Cells[0, i];
          bloodvals__overview__days.Cells[1, i + 1] := baseinfos_bloodvals_stringGrid.Cells[1, i];
          bloodvals__overview__days.Cells[2, i + 1] := baseinfos_bloodvals_stringGrid.Cells[2, i];
          bloodvals__overview__days.Cells[3, i + 1] := baseinfos_bloodvals_stringGrid.Cells[3, i];
      end;

      z := 4;
      DBGrid_bloodvals.DataSource.DataSet.First;
      for v := 0 to dsCou - 1 do
      begin

           ts := DBGrid_bloodvals.DataSource.DataSet.FieldByName('datetime1').AsString;
           ts2 := DBGrid_bloodvals.DataSource.DataSet.FieldByName('time1').AsString;
           if ts2 = '' then
           else
           begin
             ts := ts + ' - ' + ts2;
           end;
           bloodvals__overview__days.Cells[z, 0] := DBGrid_bloodvals.DataSource.DataSet.FieldByName('id').AsString;
           bloodvals__overview__days.Cells[z, 1] := ts;
           for i := 1 to baseinfos_bloodvals_stringGrid.RowCount - 3 do
           begin
                if baseinfos_bloodvals_stringGrid.Cells[0, i] = '' then
                else
                begin
                    bloodvals__overview__days.Cells[z, i + 1] := DBGrid_bloodvals.DataSource.DataSet.FieldByName(bloodvals__overview__days.Cells[0, i + 1]).AsString
                end;
           end;

           DBGrid_bloodvals.DataSource.DataSet.Next;
           z := z + 1;
      end;
    end;
    bloodvals__overview__days.DefaultColWidth := 0;
    for i := 1 to bloodvals__overview__days.ColCount - 1 do
    begin
         bloodvals__overview__days.AutoSizeColumn(i);
    end;
    bloodvals__overview__days.RowHeights[0] := 0;
  end;
end;

procedure Tform_main2.action_closeExecute(Sender: TObject);
begin
     CloseTable_bloodvals;
     Close;
end;

procedure Tform_main2.action_aboutExecute(Sender: TObject);
begin

  dlgForm_aboutsoft := Tform_aboutsoft.Create(Application);
  dlgForm_aboutsoft.ShowModal;


end;

procedure Tform_main2.action_db_openExecute(Sender: TObject);
begin

  With DIAG_OPENDB  do
    if Execute then
      OpenTable_bloodvals(FileName);

end;

procedure Tform_main2.action_db_saveExecute(Sender: TObject);
begin

end;

procedure Tform_main2.action_db_save_asExecute(Sender: TObject);
begin

end;

procedure Tform_main2.action_enter_informationsExecute(Sender: TObject);
var
  retVal_userSettingsButton: Integer;
begin
  dlgForm_userSettings := Tform_moresettings.Create(Application);
  dlgForm_userSettings.loadDatas(database_fileName + '.ini');
  dlgForm_userSettings.ShowModal;
end;


procedure Tform_main2.bloodvals__overview__daysSelectCell(Sender: TObject;
  aCol, aRow: Integer; var CanSelect: Boolean);
var
  i : Integer;
  tr : TGridRect;
begin

// ...

end;

procedure Tform_main2.bloodvals__overview__daysSelection(Sender: TObject; aCol,
  aRow: Integer);
var
   k : Integer;
begin
  if bloodvals__overview__days.RowCount > 1 then
  begin
      k := bloodvals__overview__days.TopRow;
      bloodvals__overview__days.Selection := TGridRect(Rect(bloodvals__overview__days.Col,
                                             bloodvals__overview__days.FixedRows,
                                             bloodvals__overview__days.Col,
                                             bloodvals__overview__days.RowCount-1));
      bloodvals__overview__days.TopRow := k;

      if bloodvals__overview__days.Row > 1 then
      begin
        tools_db_setActive(DBGrid_bloodvals.DataSource.DataSet, 'id', strtoint(bloodvals__overview__days.Cells[bloodvals__overview__days.Col, 0]));
      end;

  end;
end;

procedure Tform_main2.bloodvals__overview__daysClick(Sender: TObject);
begin
  // ...
end;

procedure Tform_main2.bloodvals__overview__daysDblClick(Sender: TObject);
begin
  if DBGrid_bloodvals.DataSource.DataSet.RecordCount > 0 then
  begin
    flag_doInitEdit := true;
    MainTabPageControl.ActivePage := main_tab_edit_entry;
  end;
end;

procedure Tform_main2.bloodvals__overview__daysResize(Sender: TObject);
  var i : LongInt;
begin
  bloodvals__overview__days.DefaultColWidth := 0;
  for i := 1 to bloodvals__overview__days.ColCount - 1 do
  begin
       bloodvals__overview__days.AutoSizeColumn(i);
  end;
end;

procedure Tform_main2.tools_db_getActive(daSe: TDataSet; idStr: string);
begin
  tools_result_integer := daSe.FieldByName(idStr).AsInteger;
end;

procedure Tform_main2.tools_db_setActive(daSe: TDataSet; idStr: string; idVal: Integer);
var
   flag_run: boolean;
begin
     daSe.First;
     flag_run := true;
     while flag_run = true do
     begin
       if daSe.EOF then
       begin
         flag_run := false;
       end;
       if daSe.FieldByName(idStr).AsInteger = idVal then
       begin
         flag_run := false;
       end;

       if flag_run = true then
       begin
            daSe.Next;
       end;
     end;
end;

procedure Tform_main2.tools_db_getUniqueId(daSe: TDataSet; idStr: string);
var
  newId : Integer;
  newIdStr : string;
  flag_run : boolean;
  v : Integer;
begin
  newId := 1;
  Str(newId, newIdStr);
  tools_result_string := newIdStr;

  if daSe.RecordCount > 0 then
  begin
    newId := daSe.RecordCount;
    Str(newId, newIdStr);

    flag_run := true;
    while flag_run = true do
    begin
         flag_run := false;

         daSe.First;
         for v := 0 to daSe.RecordCount - 1 do
         begin
              if daSe.FieldByName(idStr).AsString = newIdStr then
              begin
                flag_run := true;
                newId := newId + 1;
                Str(newId, newIdStr);

                flag_run := true;
              end;
              daSe.Next;
         end;
    end;

    tools_result_string := newIdStr;
  end;
end;

procedure Tform_main2.tools_db_getCount(daSe: TDataSet);
var
  flag_run : boolean;
begin
  tools_result_integer := 0;
  if daSe.Active = true then begin
    daSe.First;
    flag_run := true;
    while flag_run = true do
    begin
      if daSe.EOF then
      begin
        flag_run := false;
      end;

      if flag_run = true then
      begin
           daSe.Next;
           Inc(tools_result_integer);
      end;
    end;
  end;
end;

procedure Tform_main2.button_bloodvals_applyClick(Sender: TObject);
  var i: LongInt;
  var isEdit2: boolean;
  var uniqueId: String;
  var orgActiveId: Integer;
begin
  if flag_doEdit = true then
  begin
       tools_db_getActive(DBGrid_bloodvals.DataSource.DataSet, 'id');
       orgActiveId := tools_result_integer;
  end;

  tools_db_getUniqueId(DBGrid_bloodvals.DataSource.DataSet, 'id');
  uniqueId := tools_result_string;

  if flag_doEdit = true then
  begin
       tools_db_setActive(DBGrid_bloodvals.DataSource.DataSet, 'id', orgActiveId);
  end;

  if flag_doEdit = true then
  begin
       DBGrid_bloodvals.DataSource.DataSet.Edit;
  end;

  isEdit2 := (DBGrid_bloodvals.DataSource.DataSet.State in dsEditModes);
  if Not isEdit2 then
  begin
    DBGrid_bloodvals.DataSource.DataSet.Append;
  end;

  for i := 1 to edit_bloodvals__props.RowCount - 1 do
  begin
       if edit_bloodvals__props.Cells[0, i] = '' then
       else
       begin
           DBGrid_bloodvals.DataSource.DataSet.FieldByName(edit_bloodvals__props.Cells[0, i]).AsString := edit_bloodvals__props.Cells[4, i];
       end;
  end;
  if flag_doEdit = false then
  begin
       DBGrid_bloodvals.DataSource.DataSet.FieldByName('id').AsString := uniqueId;
  end;
  DBGrid_bloodvals.DataSource.DataSet.FieldByName('datetime1').AsString := edit_bloodvals__date1.Date;
  DBGrid_bloodvals.DataSource.DataSet.Post;
  MainTabPageControl.ActivePage := main_tab_view_entrys;

end;

procedure Tform_main2.button_bloodvals_deleteClick(Sender: TObject);
  var i : LongInt;
  var orgActiveId: Integer;
begin
  if flag_doEdit = true then
  begin
       tools_db_getActive(DBGrid_bloodvals.DataSource.DataSet, 'id');
       orgActiveId := tools_result_integer;

       form_askDeleteBloodVals := Tform_askDeleteBloodVals.Create(Application);
       form_askDeleteBloodVals.labelValue_date.Caption := edit_bloodvals__date1.Date;
       form_askDeleteBloodVals.labelValue_dateTime.Caption := edit_bloodvals__datetime1.Caption;
       form_askDeleteBloodVals.bloodvals__previewProps.RowCount := edit_bloodvals__props.RowCount;
       for i := 1 to edit_bloodvals__props.RowCount - 1 do
       begin
           form_askDeleteBloodVals.bloodvals__previewProps.Cells[0, i] := edit_bloodvals__props.Cells[1, i];
           form_askDeleteBloodVals.bloodvals__previewProps.Cells[1, i] := edit_bloodvals__props.Cells[2, i];
           form_askDeleteBloodVals.bloodvals__previewProps.Cells[2, i] := edit_bloodvals__props.Cells[3, i];
           form_askDeleteBloodVals.bloodvals__previewProps.Cells[3, i] := edit_bloodvals__props.Cells[4, i];
       end;
       if form_askDeleteBloodVals.ShowModal() = mrOK then
       begin
            tools_db_setActive(DBGrid_bloodvals.DataSource.DataSet, 'id', orgActiveId);
            DBGrid_bloodvals.DataSource.DataSet.Delete;
            flag_doEdit := false;
            flag_doInitEdit := false;
            MainTabPageControl.ActivePage := main_tab_view_entrys;
            DBGrid_bloodvals.Refresh;
            flag_actualizeDataViews := true;
            updateOverviews;
       end;
  end;
end;

procedure Tform_main2.DBGrid_bloodvalsCellClick(Column: TColumn);
begin

end;

procedure Tform_main2.DBGrid_bloodvalsDblClick(Sender: TObject);
begin
  if DBGrid_bloodvals.DataSource.DataSet.RecordCount > 0 then
  begin
    flag_doInitEdit := true;
    MainTabPageControl.ActivePage := main_tab_edit_entry;
  end;
end;

procedure Tform_main2.DSbloodvalsUpdateData(Sender: TObject);
  var i : LongInt;
begin
  flag_actualizeDataViews := true;
end;

procedure Tform_main2.edit_bloodvals__date1Change(Sender: TObject);
begin

end;

procedure Tform_main2.edit_bloodvals__propsClick(Sender: TObject);
begin
  // ...
end;

procedure Tform_main2.edit_bloodvals__propsResize(Sender: TObject);
  var re:LongInt;
begin
  edit_bloodvals__props.DefaultColWidth := 0;
  edit_bloodvals__props.AutoSizeColumn(1);
  edit_bloodvals__props.AutoSizeColumn(2);
  edit_bloodvals__props.AutoSizeColumn(3);
  edit_bloodvals__props.AutoSizeColumn(4);

end;

procedure Tform_main2.edit_bloodvals__propsSelectEditor(Sender: TObject; aCol,
  aRow: Integer; var Editor: TWinControl);
begin

end;

procedure Tform_main2.edit_bloodvals__propsSetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: string);
  var cCol: LongInt;
  var cRow: LongInt;
begin
  cCol := aCol;
  cRow := aRow;
    if cCol = LongInt(4) then
    begin
		
		// ...
		
    end;
end;

procedure Tform_main2.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
     DBAbloodvals.Close;
end;

procedure Tform_main2.FormCloseQuery(Sender: TObject; var CanClose: boolean);
begin
  CanClose:=Not (DBAbloodvals.State in dsEditModes);
  if Not CanClose then
    case MessageDlg(SSaveData,mtWarning,[mbYes,mbNo,mbCancel],0) of
      mrYes : begin
              DBAbloodvals.Post;
              CanClose:=True;
              end;
      mrNo  : CanClose:=True;
    end;
end;

procedure Tform_main2.FormCreate(Sender: TObject);
begin
  flag_inited := false;
  flag_actualizeDataViews := false;
  reportPrintData_work := false;
end;

procedure Tform_main2.FormShow(Sender: TObject);
  var i : LongInt;
  var ds : String;
begin
  if flag_inited = false then
  begin
    flag_inited := true;
    flag_isWork_cellSelect := false;

    edit_bloodvals__date1.DateTime := Now;

    for i := 1 to 199 do
    begin
         Str(i, ds);
         ds := 'Data' + ds;
         DBGrid_bloodvals.Columns.Add.FieldName := ds;
    end;
    DBGrid_bloodvals.Columns.Add.FieldName := 'datetime1';
    DBGrid_bloodvals.Columns.Add.FieldName := 'datetime2';
    DBGrid_bloodvals.Columns.Add.FieldName := 'datetime3';
    DBGrid_bloodvals.Columns.Add.FieldName := 'datetime4';
    DBGrid_bloodvals.Columns.Add.FieldName := 'date1';
    DBGrid_bloodvals.Columns.Add.FieldName := 'date2';
    DBGrid_bloodvals.Columns.Add.FieldName := 'date3';
    DBGrid_bloodvals.Columns.Add.FieldName := 'date4';
    DBGrid_bloodvals.Update;
  end;
end;

procedure Tform_main2.HaveDataNotEmpty(Sender: TObject);
begin
  With DBAbloodvals do
    (Sender as Taction).Enabled:=Active and Not (EOF and BOF);
end;

procedure Tform_main2.InEditMode(Sender: TObject);
begin
  With DBAbloodvals do
    (Sender As Taction).Enabled:=State in dsEditModes;
end;

procedure Tform_main2.main_actionsExecute(AAction: TBasicAction;
  var Handled: Boolean);
begin


end;

procedure Tform_main2.baseinfos_bloodvals_stringGridResize(Sender: TObject);
  var re: LongInt;
begin

  re := LongInt(baseinfos_bloodvals_stringGrid.Width);
  re := re - baseinfos_bloodvals_stringGrid.Columns.Items[0].Width;
  re := re - baseinfos_bloodvals_stringGrid.Columns.Items[1].Width;
  re := re - baseinfos_bloodvals_stringGrid.Columns.Items[3].Width;
  re := re - baseinfos_bloodvals_stringGrid.Columns.Items[4].Width;
  re := re - 30;
  baseinfos_bloodvals_stringGrid.Columns.Items[2].Width := re;

end;

procedure Tform_main2.main_tab_edit_entryContextPopup(Sender: TObject;
  MousePos: TPoint; var Handled: Boolean);
begin

end;

procedure Tform_main2.main_tab_edit_entryEnter(Sender: TObject);
begin

end;

procedure Tform_main2.main_tab_edit_entryShow(Sender: TObject);
  var
    i: LongInt;
    ts: string;
    wd: TDateTime;
begin
  edit_bloodvals__props.RowCount := baseinfos_bloodvals_stringGrid.RowCount;
  for i := 1 to baseinfos_bloodvals_stringGrid.RowCount - 1 do
  begin
      edit_bloodvals__props.Cells[0, i] := baseinfos_bloodvals_stringGrid.Cells[0, i];
      edit_bloodvals__props.Cells[1, i] := baseinfos_bloodvals_stringGrid.Cells[1, i];
      edit_bloodvals__props.Cells[2, i] := baseinfos_bloodvals_stringGrid.Cells[2, i];
      edit_bloodvals__props.Cells[3, i] := baseinfos_bloodvals_stringGrid.Cells[3, i];
      edit_bloodvals__props.Cells[4, i] := '';
  end;
  if flag_doInitEdit = true then
  begin
    if DBGrid_bloodvals.DataSource.DataSet.RecordCount > 0 then
    begin
      for i := 1 to baseinfos_bloodvals_stringGrid.RowCount - 1 do
      begin
         if edit_bloodvals__props.Cells[0, i] = '' then
         else
           begin
             edit_bloodvals__props.Cells[4, i] := DBGrid_bloodvals.DataSource.DataSet.FieldByName(edit_bloodvals__props.Cells[0, i]).AsString;
         end;
      end;
    end;

    button_bloodvals_delete.Show;
  end;
  if flag_doInitEdit = false then
  begin
    button_bloodvals_delete.Hide;
    edit_bloodvals__date1.DateTime := Now;
  end;
  edit_bloodvals__props.DefaultColWidth := 0;
  edit_bloodvals__props.AutoSizeColumn(1);
  edit_bloodvals__props.AutoSizeColumn(2);
  edit_bloodvals__props.AutoSizeColumn(3);
  edit_bloodvals__props.AutoSizeColumn(4);

  wd := Now;
  ts := DBGrid_bloodvals.DataSource.DataSet.FieldByName('datetime1').AsString;
  if ts = '' then
  begin
    ts := FormatDateTime('dd.mm.yyyy', wd);
    edit_bloodvals__date1.DateTime := Now;
  end;
  if ts = '' then
  else
  begin
    edit_bloodvals__date1.Date := ts;
  end;

  if flag_doInitEdit = true then
  begin
      flag_doEdit := true;
      flag_doInitEdit := false;
  end;
end;

procedure Tform_main2.main_tab_overview_daysShow(Sender: TObject);
begin
  // ...
end;

procedure Tform_main2.main_tab_stats1ContextPopup(Sender: TObject;
  MousePos: TPoint; var Handled: Boolean);
begin

end;

procedure Tform_main2.main_tab_view_entrysContextPopup(Sender: TObject;
  MousePos: TPoint; var Handled: Boolean);
begin

end;

procedure Tform_main2.main_tab_view_entrysShow(Sender: TObject);
  var i : LongInt;
begin
  if edit_bloodvals__props.RowCount > LongInt(2) then
  begin
    for i := 1 to edit_bloodvals__props.RowCount - 1 do
    begin
        edit_bloodvals__props.Cells[4, i] := '';
    end;

    if flag_doEdit = true then
    begin
        flag_doEdit := false;
    end;
  end;

  updateOverviews;
end;

procedure Tform_main2.Memo1Change(Sender: TObject);
begin

end;

procedure Tform_main2.menu_main_page_dialogExecute(Sender: TObject);
begin

end;

procedure Tform_main2.menu_main_printClick(Sender: TObject);
begin

end;

procedure Tform_main2.menu_main_print_setupExecute(Sender: TObject);
begin

end;

procedure Tform_main2.printReportBeginPage(pgNo: Integer);
begin
  reportPrintData_newActivePage := pgNo;
  if pgNo = 1 then
  begin
       if reportPrintData_colsPerPage = 0 then
       begin
            reportPrintData_colsPerPage := reportPrintData_colInPage;
            reportPrintData_colInPage := 0;
       end;
  end;
  reportPrintData_managePages := reportPrintData_managePages + 1;
  reportPrintData_headerCol := 0;
  reportPrintData_headerRow := 0;
  reportPrintData_manageHeader_row := true;
  reportPrintData_manageHeader_col := true;
end;

procedure Tform_main2.printReportEnterRect(Memo: TStringList; View: TfrView);
begin
  if View.Name = 'Memo7' then
  begin
    View.FillColor := RGBToColor(255, 255, 255);
      if reportPrintData_headerCol < 3 then begin
        View.FillColor := RGBToColor(235, 235, 235);
      end;
    if reportPrintData_row = 0 then begin
      View.FillColor := RGBToColor(235, 235, 235);
    end;
  end;
end;

procedure Tform_main2.printReportGetValue(const ParName: String;
  var ParValue: Variant);
begin

  if ParName = 'data_cust_prename' then
  begin
    ParValue := reportPrintData_customDataList.Strings[ 0 ];
  end;

  if ParName = 'data_cust_lastname' then
  begin
    ParValue := reportPrintData_customDataList.Strings[ 1 ];
  end;

  if ParName = 'data_cust_street' then
  begin
    ParValue := reportPrintData_customDataList.Strings[ 2 ];
  end;

  if ParName = 'data_cust_streetnr' then
  begin
    ParValue := reportPrintData_customDataList.Strings[ 3 ];
  end;

  if ParName = 'data_cust_loczip' then
  begin
    ParValue := reportPrintData_customDataList.Strings[ 4 ];
  end;

  if ParName = 'data_cust_loc' then
  begin
    ParValue := reportPrintData_customDataList.Strings[ 5 ];
  end;

  if ParName = 'data_cust_land' then
  begin
    ParValue := reportPrintData_customDataList.Strings[ 6 ];
  end;

  if ParName = 'data_doc_prename' then
  begin
    ParValue := reportPrintData_customDataList.Strings[ 7 ];
  end;

  if ParName = 'data_doc_lastname' then
  begin
    ParValue := reportPrintData_customDataList.Strings[ 8 ];
  end;

  if ParName = 'data_doc_street' then
  begin
    ParValue := reportPrintData_customDataList.Strings[ 9 ];
  end;

  if ParName = 'data_doc_streetnr' then
  begin
    ParValue := reportPrintData_customDataList.Strings[ 10 ];
  end;

  if ParName = 'data_doc_loczip' then
  begin
    ParValue := reportPrintData_customDataList.Strings[ 11 ];
  end;

  if ParName = 'data_doc_loc' then
  begin
    ParValue := reportPrintData_customDataList.Strings[ 12 ];
  end;

  if ParName = 'data_doc_land' then
  begin
    ParValue := reportPrintData_customDataList.Strings[ 13 ];
  end;

  if ParName = 'data_cust_title' then
  begin
    ParValue := reportPrintData_customDataList.Strings[ 14 ];
  end;

  if ParName = 'data_doc_title' then
  begin
    ParValue := reportPrintData_customDataList.Strings[ 15 ];
  end;

  if ParName = 'data_cust_sex' then
  begin
    if reportPrintData_customDataList.Strings[ 16 ] = '1' then begin
      ParValue := 'Herr';
    end;
    if reportPrintData_customDataList.Strings[ 16 ] = '2' then begin
      ParValue := 'Frau';
    end;
  end;

  if ParName = 'S2' then
  begin
    ParValue := 's';
  end;

  if ParName = 'S1' then
  begin
    ParValue := 'q';
    ParValue := 'q';
    if reportPrintData_activePage <> reportPrintData_newActivePage then
    begin
      reportPrintData_activePage := reportPrintData_newActivePage;
    end;

    if reportPrintData_headerRow = 0 then begin
      if reportPrintData_colInPage = 0 then begin
        ParValue := ' Bezeichnung';
      end;
      if reportPrintData_colInPage = 1 then begin
        ParValue := ' Einheit';
      end;
      if reportPrintData_colInPage = 2 then begin
        ParValue := ' Normalwert';
      end;
      if reportPrintData_colInPage > 2 then begin
        ParValue := ' ' + bloodvals__overview__days.Cells[reportPrintData_col + 4, reportPrintData_row + 1];
      end;
    end;

    if reportPrintData_row > 0 then begin
       if reportPrintData_colInPage = 0 then begin
          ParValue := ' ' + bloodvals__overview__days.Cells[2, reportPrintData_row + 1];
       end;
       if reportPrintData_colInPage = 1 then begin
          ParValue := ' ' + bloodvals__overview__days.Cells[3, reportPrintData_row + 1];
       end;
       if reportPrintData_colInPage = 2 then begin
          ParValue := ' ' + baseinfos_bloodvals_stringGrid.Cells[4, reportPrintData_row];
       end;
       if reportPrintData_colInPage > 2 then begin
         ParValue := ' ' + bloodvals__overview__days.Cells[reportPrintData_col + 4, reportPrintData_row + 1];
       end;
    end;
  end;
end;

procedure Tform_main2.printReportPrintColumn(ColNo: Integer; var wWidth: Integer );
begin
  if reportPrintData_colInPage = 0 then begin
     wWidth := 120;
  end;
  if reportPrintData_colInPage = 1 then begin
     wWidth := 60;
  end;
  if reportPrintData_colInPage = 2 then begin
     wWidth := 90;
  end;
  if reportPrintData_colInPage > 2 then begin
     wWidth := 120;
  end;
end;

procedure Tform_main2.reportPrintData_bloodPropsCheckEOF(Sender: TObject;
  var Eof: Boolean);
begin
    Eof:=(reportPrintData_row>(bloodvals__overview__days.RowCount-2));
    reportPrintData_work := false;
    if Eof = false then begin
      reportPrintData_work := true;
    end;
end;

procedure Tform_main2.reportPrintData_bloodPropsFirst(Sender: TObject);
begin
  reportPrintData_work := true;
  reportPrintData_headerRow := 0;
  reportPrintData_row := 0;
  if reportPrintData_manageHeader_row = true then begin
  end;
  if reportPrintData_manageHeader_row = false then begin
  end;
end;

procedure Tform_main2.reportPrintData_bloodPropsNext(Sender: TObject);
begin
  reportPrintData_work := true;
  Inc(reportPrintData_headerRow);
  Inc(reportPrintData_row);
  reportPrintData_headerCol := 0;
  reportPrintData_col := 0;
  reportPrintData_manageHeader_col := true;
end;

procedure Tform_main2.reportPrintData_bloodValuesCheckEOF(Sender: TObject;
  var Eof: Boolean);
begin
  Eof:=(reportPrintData_col>((bloodvals__overview__days.ColCount)-2)-3);
  reportPrintData_work := false;
  if Eof = false then begin
    reportPrintData_work := true;
  end;
end;

procedure Tform_main2.reportPrintData_bloodValuesFirst(Sender: TObject);
begin
  reportPrintData_work := true;
  if reportPrintData_manageHeader_col = true then begin
    reportPrintData_headerCol := 0;
  end;
  if reportPrintData_manageHeader_col = false then begin
    reportPrintData_col := 0;
  end;
  reportPrintData_colInPage := 0;
end;

procedure Tform_main2.reportPrintData_bloodValuesNext(Sender: TObject);
begin
  reportPrintData_work := true;
  if reportPrintData_manageHeader_col = true then begin
    Inc(reportPrintData_headerCol);
  end;
  if reportPrintData_manageHeader_col = false then begin
    Inc(reportPrintData_col);
  end;
  if reportPrintData_manageHeader_col = true then begin
    if reportPrintData_headerCol > 2 then begin
      reportPrintData_manageHeader_col := false;
    end;
  end;
  Inc(reportPrintData_colInPage);
  if reportPrintData_colsPerPage > 0 then begin
    if reportPrintData_colInPage > reportPrintData_colsPerPage - 1 then begin
      reportPrintData_colInPage := 0;
      reportPrintData_manageHeader_col := true;
      reportPrintData_headerCol := 0;
    end;
  end;
end;

procedure Tform_main2.ValueListEditor1Click(Sender: TObject);
begin
end;


procedure Tform_main2.action_page_dialogExecute(Sender: TObject);
begin
  If PageSetupDialog1.Execute then
  begin
    // ...
  end;
end;

function Tform_main2.printView_print(requiredInfo: Integer; pageObjType: String; pageIndex: Integer; dataSrc: TDatasource): String;
var
  info_entrysPerPage:Integer;
  tableS:String;
  tableNlS:String;
  retVal:String;
  iRow: Integer;
  iCol: Integer;
  stringTable: tool_stringTable;
begin
  if pageObjType = 'table_bloodvals' then
  begin
    if requiredInfo = 0 then 
    begin
      info_entrysPerPage := dataSrc.DataSet.FieldByName('DATA1').AsInteger;

      
      if bloodvals__overview__days.ColCount - 4 = 0 then
      begin
        retVal := '0';
      end;
      if bloodvals__overview__days.ColCount - 4 > 0 then
      begin
        retVal := IntToStr( ceil((bloodvals__overview__days.ColCount - 4) / info_entrysPerPage) );
        if retVal = '' then
        begin
          retVal := '0';
        end;
      end;
    end;

    if requiredInfo = 1 then 
    begin
      retVal := '';
    end;

    if requiredInfo = 2 then 
    begin
      stringTable := tool_stringTable.Create;
      for iRow := 1 to bloodvals__overview__days.RowCount - 1 do
      begin
        stringTable.beginRow();
        for iCol := 1 to 3 do
        begin
          retVal := bloodvals__overview__days.Cells[iCol, iRow];
          stringTable.addCell(retVal);
          stringTable.addCellInfo('asasd', '1340');
          stringTable.addCellInfo('padding', '10');
        end;

        for iCol := 4 to bloodvals__overview__days.ColCount - 1 do
        begin
          retVal := bloodvals__overview__days.Cells[iCol, iRow];
          stringTable.addCell(retVal);
        end;
        stringTable.endRow();
      end;
      retVal := stringTable.getAsString();
      stringTable.free();
    end;
  end;

  printView_print := retVal;
end;

procedure Tform_main2.action_print_alternative;
var
    flag_print : LongInt;
    setDataColor : libdlgform_rgbcolor;
    data_fgColor_RGB : Integer;
    data_bgColor_RGB : Integer;
begin
  dlgForm_print := Tform_dlg_print.Create(Application);
  dlgForm_print.data_html := 'This is a <b>hello</b> world.';

  dlgForm_print.data_page_dpi := 300; // DIN A4
  dlgForm_print.data_page_pixel_width := 2480; // DIN A4
  dlgForm_print.data_page_pixel_height := 3508; // DIN A4
  dlgForm_print.data_page_pixel_margin_left := 200; // DIN A4
  dlgForm_print.data_page_pixel_margin_top := 200; // DIN A4
  dlgForm_print.data_page_pixel_margin_right := 400; // DIN A4
  dlgForm_print.data_page_pixel_margin_bottom := 400; // DIN A4

  setDataColor.red := 255;
  setDataColor.green := 255;
  setDataColor.blue := 255;
  data_bgColor_RGB := dlgForm_print.rgb2color(setDataColor);

  setDataColor.red := 0;
  setDataColor.green := 0;
  setDataColor.blue := 0;
  data_fgColor_RGB := dlgForm_print.rgb2color(setDataColor);

  dlgForm_print.data_designElementHandler := @printView_print;
  dlgForm_print.addDesignElement('table_bloodvals', 'Blutwerte', 10, 10, 'Verdana', 10, data_bgColor_RGB, data_fgColor_RGB, '' );
  dlgForm_print.setLastAddedDesignElementData(1, '3');

  flag_print := dlgForm_print.ShowModal;

  if dlgForm_print.returnCode = 0 then  
  begin
    // ...
  end;

  if dlgForm_print.returnCode = 1 then  
  begin
    // ...
  end;

  if dlgForm_print.returnCode = 2 then  
  begin
    // ...
  end;

end;

procedure Tform_main2.action_printExecute(Sender: TObject);
var
    ii: Integer;
begin
  reportPrintData_activePage := 0 - 1;
  reportPrintData_newActivePage := 0;
  reportPrintData_manageHeader_col := true;
  reportPrintData_manageHeader_row := true;
  reportPrintData_dataRow := 0;
  reportPrintData_dataCol := 0;
  reportPrintData_headerRow := 0;
  reportPrintData_headerCol := 0;
  reportPrintData_colsPerPage := 0;
  reportPrintData_colInPage := 0;
  reportPrintData_managePages := 0 - 1;
  reportPrintData_doNotForgetheaderCols := 0;
  if Not FileExists(database_fileName + '.ini') then begin
    reportPrintData_customDataList := TStringList.Create;
  end;
  if FileExists(database_fileName + '.ini') then begin
     reportPrintData_customDataList := TStringList.Create;
     reportPrintData_customDataList.LoadFromFile(database_fileName + '.ini');
  end;
  for ii := 1 to 100 do
  begin
    reportPrintData_customDataList.Append('');
  end;
  printReport.ModalPreview := true;
  printReport.ShowReport;
  if FileExists(database_fileName + '.ini') then begin
     reportPrintData_customDataList.Free;
  end;
end;

procedure Tform_main2.action_print_setupExecute(Sender: TObject);
begin
  If PrinterSetupDialog1.Execute then
  begin
    // ...
  end;
end;



{ Tform_main2 }




end.

