unit form_morsett;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ButtonPanel,
  StdCtrls, IniPropStorage, XMLPropStorage, IDEWindowIntf;


type

  { Tform_moresettings }

  Tform_moresettings = class(TForm)
    Button1: TButton;
    Button2: TButton;
    inp_doc_title: TEdit;
    inp_doc_street: TEdit;
    inp_cust_land: TEdit;
    inp_doc_streetnr: TEdit;
    inp_doc_loczip: TEdit;
    inp_doc_loc: TEdit;
    inp_doc_land: TEdit;
    inp_cust_street: TEdit;
    inp_cust_streetnr: TEdit;
    inp_cust_loczip: TEdit;
    inp_cust_loc: TEdit;
    GroupBox2: TGroupBox;
    inp_doc_prename: TEdit;
    GroupBox1: TGroupBox;
    inp_doc_lastname: TEdit;
    inp_cust_prename: TEdit;
    inp_cust_lastname: TEdit;
    inp_cust_title: TEdit;
    Label1: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    inp_cust_sex_man: TRadioButton;
    inp_cust_sex_woman: TRadioButton;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure okButtonClick(Sender: TObject);
    procedure closeButtonClick(Sender: TObject);
  private
    { private declarations }
    IniPropStorage2: TIniPropStorage;
    saveFileName: String;
    data_shows: Integer;
  public
    procedure loadDatas(fileName: String);
    procedure saveDatas(fileName: String);
    { public declarations }
  end;

var
  form_moresettings: Tform_moresettings;

implementation

{$R *.lfm}

{ Tform_moresettings }

procedure Tform_moresettings.ListBox1Click(Sender: TObject);
begin

end;

procedure Tform_moresettings.FormShow(Sender: TObject);
begin
  if data_shows = 0 then begin
    inp_doc_title.SetFocus;
  end;
  Inc(data_shows);
end;

procedure Tform_moresettings.FormCreate(Sender: TObject);
begin
  data_shows := 0;
end;

procedure Tform_moresettings.okButtonClick(Sender: TObject);
var
  flag_validInputs : boolean;
  text_error: String;
begin
  flag_validInputs := true;
  if inp_doc_title.Text = '' then begin
    flag_validInputs := false;
    text_error := 'Behandelnder Arzt: Titel / Anrede ist nicht angegeben';
  end;
  if inp_doc_prename.Text = '' then begin
    flag_validInputs := false;
    text_error := 'Behandelnder Arzt: Vorname ist nicht angegeben';
  end;
  if inp_doc_lastname.Text = '' then begin
    flag_validInputs := false;
    text_error := 'Behandelnder Arzt: Nachname ist nicht angegeben';
  end;
  if inp_doc_street.Text = '' then begin
    flag_validInputs := false;
    text_error := 'Behandelnder Arzt: Straße ist nicht angegeben';
  end;
  if inp_doc_streetnr.Text = '' then begin
    flag_validInputs := false;
    text_error := 'Behandelnder Arzt: Hausnummer ist nicht angegeben';
  end;
  if inp_doc_loczip.Text = '' then begin
    flag_validInputs := false;
    text_error := 'Behandelnder Arzt: Postleitzahl ist nicht angegeben';
  end;
  if inp_doc_loc.Text = '' then begin
    flag_validInputs := false;
    text_error := 'Behandelnder Arzt: Ort ist nicht angegeben';
  end;
  if inp_doc_land.Text = '' then begin
    flag_validInputs := false;
    text_error := 'Behandelnder Arzt: Land ist nicht angegeben';
  end;
  if inp_cust_title.Text = '' then begin
    // ...
  end;
  if inp_cust_prename.Text = '' then begin
    flag_validInputs := false;
    text_error := 'Kunde / Patient: Vorname ist nicht angegeben';
  end;
  if inp_cust_lastname.Text = '' then begin
    flag_validInputs := false;
    text_error := 'Kunde / Patient: Nachname ist nicht angegeben';
  end;
  if inp_cust_street.Text = '' then begin
    flag_validInputs := false;
    text_error := 'Kunde / Patient: Straße ist nicht angegeben';
  end;
  if inp_cust_streetnr.Text = '' then begin
    flag_validInputs := false;
    text_error := 'Kunde / Patient: Hausnummer ist nicht angegeben';
  end;
  if inp_cust_loczip.Text = '' then begin
    flag_validInputs := false;
    text_error := 'Kunde / Patient: Postleitzahl ist nicht angegeben';
  end;
  if inp_cust_loc.Text = '' then begin
    flag_validInputs := false;
    text_error := 'Kunde / Patient: Ort ist nicht angegeben';
  end;
  if inp_cust_land.Text = '' then begin
    flag_validInputs := false;
    text_error := 'Kunde / Patient: Land ist nicht angegeben';
  end;
  if inp_cust_sex_man.Checked = false then begin
    if inp_cust_sex_woman.Checked = false then begin
      flag_validInputs := false;
      text_error := 'Kunde / Patient: Geschlecht ist nicht ausgewählt';
    end;
  end;

  if flag_validInputs = false then begin
    MessageDlg('Bitte Angaben überprüfen:', text_error, mtError, [mbOK], '');
  end;

  if flag_validInputs = true then begin
    saveDatas(saveFileName);
    Close;
  end;
end;

procedure Tform_moresettings.closeButtonClick(Sender: TObject);
begin
  Close;
end;

procedure Tform_moresettings.loadDatas(fileName: String);
var
  loadDataList: TStringList;
  ii: Integer;
begin
  saveFileName := fileName;

  inp_cust_title.Text := '';
  inp_cust_prename.Text := '';
  inp_cust_lastname.Text := '';
  inp_cust_street.Text := '';
  inp_cust_streetnr.Text := '';
  inp_cust_loczip.Text := '';
  inp_cust_loc.Text := '';
  inp_cust_land.Text := '';
  inp_doc_title.Text := '';
  inp_doc_prename.Text := '';
  inp_doc_lastname.Text := '';
  inp_doc_street.Text := '';
  inp_doc_streetnr.Text := '';
  inp_doc_loczip.Text := '';
  inp_doc_loc.Text := '';
  inp_doc_land.Text := '';

  if FileExists(fileName) then begin
    loadDataList := TStringList.Create;
    loadDataList.LoadFromFile(fileName);
    for ii := 1 to 100 do
    begin
      loadDataList.Append('');
    end;
    inp_cust_prename.Text := loadDataList.Strings[ 0 ];
    inp_cust_lastname.Text := loadDataList.Strings[ 1 ];
    inp_cust_street.Text := loadDataList.Strings[ 2 ];
    inp_cust_streetnr.Text := loadDataList.Strings[ 3 ];
    inp_cust_loczip.Text := loadDataList.Strings[ 4 ];
    inp_cust_loc.Text := loadDataList.Strings[ 5 ];
    inp_cust_land.Text := loadDataList.Strings[ 6 ];
    inp_doc_prename.Text := loadDataList.Strings[ 7 ];
    inp_doc_lastname.Text := loadDataList.Strings[ 8 ];
    inp_doc_street.Text := loadDataList.Strings[ 9 ];
    inp_doc_streetnr.Text := loadDataList.Strings[ 10 ];
    inp_doc_loczip.Text := loadDataList.Strings[ 11 ];
    inp_doc_loc.Text := loadDataList.Strings[ 12 ];
    inp_doc_land.Text := loadDataList.Strings[ 13 ];
    inp_cust_title.Text := loadDataList.Strings[ 14 ];
    inp_doc_title.Text := loadDataList.Strings[ 15 ];
    if loadDataList.Strings[ 16 ] = '1' then begin
      inp_cust_sex_man.Checked := true;
    end;
    if loadDataList.Strings[ 16 ] = '2' then begin
      inp_cust_sex_woman.Checked := true;
    end;
    loadDataList.Free;
  end;
end;


procedure Tform_moresettings.saveDatas(fileName: String);
var
  saveDataList: TStringList;
begin
  saveDataList := TStringList.Create;
  saveDataList.Add( inp_cust_prename.Text );
  saveDataList.Add( inp_cust_lastname.Text );
  saveDataList.Add( inp_cust_street.Text );
  saveDataList.Add( inp_cust_streetnr.Text );
  saveDataList.Add( inp_cust_loczip.Text );
  saveDataList.Add( inp_cust_loc.Text );
  saveDataList.Add( inp_cust_land.Text );
  saveDataList.Add( inp_doc_prename.Text );
  saveDataList.Add( inp_doc_lastname.Text );
  saveDataList.Add( inp_doc_street.Text );
  saveDataList.Add( inp_doc_streetnr.Text );
  saveDataList.Add( inp_doc_loczip.Text );
  saveDataList.Add( inp_doc_loc.Text );
  saveDataList.Add( inp_doc_land.Text );
  saveDataList.Add( inp_cust_title.Text );
  saveDataList.Add( inp_doc_title.Text );
  if inp_cust_sex_man.Checked = true then begin
    saveDataList.Add( '1' );
  end;
  if inp_cust_sex_woman.Checked = true then begin
    saveDataList.Add( '2' );
  end;
  saveDataList.SaveToFile(fileName);
  saveDataList.Free;
end;


end.

