unit libdlgform_print;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, DividerBevel, IpHtml, PrintersDlgs, LR_Class,
  Forms, Controls, Graphics, Dialogs, ExtCtrls, StdCtrls, ComCtrls, Arrow,
  DbCtrls, DBGrids, math, memds, db, BufDataset, dbf, types, tools_stringTable;

type libdlgform_rgbcolor = record
  red,blue,green:integer;
end;


type

  Tdlg_print_designElementHandler = function(requiredInfo: Integer; pageObjType: String; pageIndex: Integer; dataSrc: TDatasource): String of object;

  { Tform_dlg_print }

  Tform_dlg_print = class(TForm)
    Arrow1: TArrow;
    Arrow2: TArrow;
    button_dsg_open: TButton;
    button_dsg_save: TButton;
    button_dsg_elementFgColor: TColorButton;
    button_dsg_elementFont: TButton;
    Button3: TButton;
    button_dsg_addText: TButton;
    button_dsg_addActualPage: TButton;
    button_dsg_addPageCount: TButton;
    button_page_setup: TButton;
    button_print_setup: TButton;
    button_print: TButton;
    button_dsg_elementBgColor: TColorButton;
    input_dsg_elementAlignX: TComboBox;
    input_dsg_elementAlignY: TComboBox;
    DBCheckBox1: TDBCheckBox;
    DBCheckBox2: TDBCheckBox;
    DBCheckBox3: TDBCheckBox;
    DBCheckBox4: TDBCheckBox;
    DBEdit1: TDBEdit;
    DBMemo1: TDBMemo;
    fontDialog_elementFgColor: TColorDialog;
    fontDialog_elementBgColor: TColorDialog;
    content_background1: TPanel;
    content_background2: TShape;
    content_html: TIpHtmlPanel;
    content_image: TImage;
    Datasource1: TDatasource;
    Dbf1: TDbf;
    DBGrid1: TDBGrid;
    DBText1: TDBText;
    DBText2: TDBText;
    FontDialog1: TFontDialog;
    buffer_image: TImage;
    input_dsg_elementPosY: TDBEdit;
    input_dsg_elementPosX: TDBEdit;
    DBNavigator1: TDBNavigator;
    elSettings_dsg_text: TTabSheet;
    GroupBox1: TGroupBox;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Memo1: TMemo;
    pagectrl_dsg_elementSettings: TPageControl;
    PageSetupDialog1: TPageSetupDialog;
    Panel12: TPanel;
    Panel13: TPanel;
    Panel14: TPanel;
    elSettings_dsg_font: TPanel;
    Panel15: TPanel;
    Panel16: TPanel;
    Panel17: TPanel;
    elSettings_dsg_default: TPanel;
    panel_element_settings_extended_container: TPanel;
    panel_element_settings: TPanel;
    panel_element_list: TPanel;
    PrintDialog1: TPrintDialog;
    PrinterSetupDialog1: TPrinterSetupDialog;
    ScrollBox: TScrollBox;
    ScrollBox1: TScrollBox;
    elSettings_dsg_table_bloodvals: TTabSheet;
    updateHtmlContentUpdateTimer: TTimer;
    view_zoom: TComboBox;
    edit_page_from: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    edit_page_to: TLabel;
    Panel1: TPanel;
    Panel10: TPanel;
    Panel11: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    Panel6: TPanel;
    Panel7: TPanel;
    Panel8: TPanel;
    Panel9: TPanel;
    resizeUpdateTimer: TTimer;
    Shape1: TShape;
    procedure button_dsg_elementBgColorClick(Sender: TObject);
    procedure button_dsg_elementBgColorColorChanged(Sender: TObject);
    procedure button_dsg_elementFgColorColorChanged(Sender: TObject);
    procedure button_dsg_elementFontClick(Sender: TObject);
    procedure Datasource1DataChange(Sender: TObject; Field: TField);
    procedure Datasource1StateChange(Sender: TObject);
    procedure Datasource1UpdateData(Sender: TObject);
    procedure DBGrid1CellClick(Column: TColumn);
    procedure DBGrid1EditingDone(Sender: TObject);
    procedure DBGrid1EndDrag(Sender, Target: TObject; X, Y: Integer);
    procedure DBGrid1Enter(Sender: TObject);
    procedure DBGrid1KeyPress(Sender: TObject; var Key: char);
    procedure DBGrid1KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure DBGrid1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure DBGrid1TitleClick(Column: TColumn);
    procedure elSettings_dsg_table_bloodvalsContextPopup(Sender: TObject;
      MousePos: TPoint; var Handled: Boolean);
    procedure fontDialog_elementBgColorClose(Sender: TObject);
    procedure fontDialog_elementFgColorClose(Sender: TObject);
    procedure input_dsg_elementAlignXChange(Sender: TObject);
    procedure input_dsg_elementAlignYChange(Sender: TObject);
    procedure Memo1Change(Sender: TObject);
    procedure Memo1EditingDone(Sender: TObject);
    function rgb2color(rgb:libdlgform_rgbcolor):Integer;
    function color2rgb(colr:Integer):libdlgform_rgbcolor;
    procedure addDesignElement(preType: string; preTypePublic: string; prePosX: Integer; prePosY: Integer; preFontName: string; preFontSize: Integer; preBgColor: Integer; preFgColor: Integer; preContent: string);
    procedure setLastAddedDesignElementData(elementDataIndex: Integer; elementDataValue: String);
    procedure button_dsg_addActualPageClick(Sender: TObject);
    procedure button_dsg_addPageCountClick(Sender: TObject);
    procedure button_dsg_addTextClick(Sender: TObject);
    procedure button_page_setupClick(Sender: TObject);
    procedure button_printClick(Sender: TObject);
    procedure button_print_setupClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure pagectrl_dsg_elementSettingsChange(Sender: TObject);
    procedure PageSetupDialog1CanClose(Sender: TObject; var CanClose: boolean);
    procedure PageSetupDialog1Close(Sender: TObject);
    procedure PageSetupDialog1Show(Sender: TObject);
    procedure Panel1Click(Sender: TObject);
    procedure Panel3Click(Sender: TObject);
    procedure panel_element_listClick(Sender: TObject);
    procedure renderBitmapToImage(bitBmp: TImage; pBox: TImage; Scale: double);
    procedure renderHtmlToImage(htmlPanel: TIpHtmlPanel; pBox: TImage; Scale: double);
    procedure resizeUpdateTimerStopTimer(Sender: TObject);
    procedure resizeUpdateTimerTimer(Sender: TObject);
    procedure ScrollBoxResize(Sender: TObject);
    procedure editedDesignerField;
    procedure readPageCount;
    procedure beginDesignerEditElement;
    procedure endDesignerEditElement;
    procedure manageDesignerGUI;
    procedure updateHtmlContentUpdateTimerTimer(Sender: TObject);
    procedure updateVisualMainView;
    procedure resizeUpdateMainView;
    procedure adjustMainView;
    procedure updateHtmlContent;
  private
    procedure tools_db_getActive(daSe: TDataSet; idStr: string);
    procedure tools_db_setActive(daSe: TDataSet; idStr: string; idVal: Integer);
    procedure tools_db_getUniqueId(daSe: TDataSet; idStr: string);
    var
    tools_result_string: String;
    tools_result_LongInt: LongInt;
    tools_result_integer: Integer;

    flag_initShow: boolean;
    use_scale: double;

    use_page_dpi: Integer;
    use_page_pixel_width: Integer;
    use_page_pixel_height: Integer;

    page_dpi: Integer;
    page_pixel_width: Integer;
    page_pixel_height: Integer;
    page_pixel_margin_left: Integer;
    page_pixel_margin_top: Integer;
    page_pixel_margin_right: Integer;
    page_pixel_margin_bottom: Integer;
    page_rendered: TImage;

    page_activePage: Integer;
    page_count: Integer;

    default_page_dpi: Integer;
    default_page_pixel_width: Integer;
    default_page_pixel_height: Integer;

    flag_visualActive: boolean;
    flag_isChange_elementBgColor: boolean;
    flag_isChange_elementFgColor: boolean;
    flag_isChange_elementAlignX: boolean;
    flag_isChange_elementAlignY: boolean;

    flag_designer_showFontProps: boolean;

    flag_isManageDesignGUI: boolean;

    { private declarations }
  public
    data_page_dpi: Integer;
    data_page_pixel_width: Integer;
    data_page_pixel_height: Integer;
    data_page_pixel_margin_left: Integer;
    data_page_pixel_margin_top: Integer;
    data_page_pixel_margin_right: Integer;
    data_page_pixel_margin_bottom: Integer;

    data_designElementHandler: Tdlg_print_designElementHandler;

    data_html: string;

    returnCode: Integer;
    { public declarations }
  end;

var
  form_dlg_print: Tform_dlg_print;

implementation

{$R *.lfm}

{ Tform_dlg_print }

procedure Tform_dlg_print.FormCreate(Sender: TObject);
begin
  flag_visualActive := false;
  flag_initShow := true;

  use_scale := 1.0;

  default_page_dpi := 72;
  default_page_pixel_width := 2480;
  default_page_pixel_height := 3508;

  page_dpi := default_page_dpi;
  page_pixel_width := default_page_pixel_width;
  page_pixel_height := default_page_pixel_height;
  page_activePage := 0;
  page_count := 0;

  returnCode := 0;

  flag_isChange_elementFgColor := false;
  flag_isChange_elementBgColor := false;
  flag_isChange_elementAlignX := false;
  flag_isChange_elementAlignY := false;

  flag_designer_showFontProps := false;

  flag_isManageDesignGUI := false;
end;

procedure Tform_dlg_print.tools_db_getActive(daSe: TDataSet; idStr: string);
begin
  tools_result_integer := daSe.FieldByName(idStr).AsInteger;
end;

procedure Tform_dlg_print.tools_db_setActive(daSe: TDataSet; idStr: string; idVal: Integer);
var
   flag_run: boolean;
begin
     daSe.First;
     flag_run := true;
     while flag_run = true do
     begin
       if daSe.EOF then
       begin
         flag_run := false;
       end;
       if daSe.FieldByName(idStr).AsInteger = idVal then
       begin
         flag_run := false;
       end;

       if flag_run = true then
       begin
            daSe.Next;
       end;
     end;
end;

procedure Tform_dlg_print.tools_db_getUniqueId(daSe: TDataSet; idStr: string);
var
  newId : Integer;
  newIdStr : string;
  flag_run : boolean;
  v : Integer;
begin
  newId := 1;
  Str(newId, newIdStr);
  tools_result_string := newIdStr;

  if daSe.RecordCount > 0 then
  begin
    newId := daSe.RecordCount;
    Str(newId, newIdStr);

    flag_run := true;
    while flag_run = true do
    begin
         flag_run := false;

         daSe.First;
         for v := 0 to daSe.RecordCount - 1 do
         begin
              if daSe.FieldByName(idStr).AsString = newIdStr then
              begin
                flag_run := true;
                newId := newId + 1;
                Str(newId, newIdStr);

                flag_run := true;
              end;
              daSe.Next;
         end;
    end;

    tools_result_string := newIdStr;
  end;
end;

procedure Tform_dlg_print.readPageCount;
var
   flag_run: boolean;

   elementData_type: String;
   elementData_pageCount: Integer;
begin
     page_count := 0;

     Datasource1.DataSet.First;
     flag_run := true;
     while flag_run = true do
     begin
       if Datasource1.DataSet.EOF then
       begin
         flag_run := false;
       end;
       if flag_run = true then
       begin
         elementData_type := Datasource1.DataSet.FieldByName('TYPE').AsString;
         elementData_pageCount := StrToInt( data_designElementHandler(0, elementData_type, page_activePage, Datasource1) );

         if elementData_pageCount > page_count then
         begin
           page_count := elementData_pageCount;
         end;

         Datasource1.DataSet.Next;
       end;
     end;

     if page_count = 0 then
     begin
          returnCode := 2;
          close;
     end;
end;

function Tform_dlg_print.rgb2color(rgb:libdlgform_rgbcolor):integer;
begin
     result:=(((rgb.blue*256)+rgb.green)*256)+rgb.red
end;

procedure Tform_dlg_print.Memo1EditingDone(Sender: TObject);
begin

end;

procedure Tform_dlg_print.Memo1Change(Sender: TObject);
begin

end;

procedure Tform_dlg_print.beginDesignerEditElement;
var
  isEdit2: boolean;
  flag_isAnyEdit: boolean;
begin
  flag_isAnyEdit := false;
  if Datasource1.DataSet.RecordCount > 0 then
  begin
    isEdit2 := (Datasource1.DataSet.State in dsEditModes);
    if isEdit2 then
    begin
      flag_isAnyEdit := true;
    end;
  end;

  if flag_isAnyEdit = false then
  begin
    Datasource1.DataSet.Edit;
  end;
end;

procedure Tform_dlg_print.endDesignerEditElement;
var
  isEdit2: boolean;
  flag_isAnyEdit: boolean;
begin
  flag_isAnyEdit := false;
  if Datasource1.DataSet.RecordCount > 0 then
  begin
    isEdit2 := (Datasource1.DataSet.State in dsEditModes);
    if isEdit2 then
    begin
      flag_isAnyEdit := true;
    end;
  end;

  if flag_isAnyEdit = true then
  begin
    Datasource1.DataSet.Post;
    Datasource1.DataSet.Edit;
  end;
end;

procedure Tform_dlg_print.manageDesignerGUI;
var
  isEdit2: boolean;
  flag_isAnyEdit: boolean;
  data_bgColor_RGB: libdlgform_rgbcolor;
  data_fgColor_RGB: libdlgform_rgbcolor;
  colr: TColor;
  i: Integer;
begin
  if flag_isManageDesignGUI = false then
  begin
    flag_isManageDesignGUI := true;

    flag_isAnyEdit := false;
    if Datasource1.DataSet.RecordCount > 0 then
    begin
      if Datasource1.DataSet.RecNo > 0 then
      begin
        flag_isAnyEdit := true;
        isEdit2 := (Datasource1.DataSet.State in dsEditModes);
        if isEdit2 then
        begin
        end;
      end;
    end;

    if flag_isAnyEdit = true then
    begin
      flag_designer_showFontProps := false;

     if Not (StringReplace(Datasource1.DataSet.FieldByName('TYPE').AsString, 'table_', '', []) = Datasource1.DataSet.FieldByName('TYPE').AsString) then
      begin
        flag_designer_showFontProps := true;
      end;

      if Datasource1.DataSet.FieldByName('TYPE').AsString = 'text' then
      begin
           flag_designer_showFontProps := true;
      end;
      if Datasource1.DataSet.FieldByName('TYPE').AsString = 'number_page_index' then
      begin
           flag_designer_showFontProps := true;
      end;
      if Datasource1.DataSet.FieldByName('TYPE').AsString = 'number_page_count' then
      begin
           flag_designer_showFontProps := true;
      end;

      elSettings_dsg_font.Visible := flag_designer_showFontProps;

      pagectrl_dsg_elementSettings.Hide;
      for i := 0 to pagectrl_dsg_elementSettings.PageCount - 1 do
      begin
        if StringReplace(pagectrl_dsg_elementSettings.Pages[i].Name, 'elSettings_dsg_', '', []) = Datasource1.DataSet.FieldByName('TYPE').AsString then
        begin
          pagectrl_dsg_elementSettings.TabIndex := i;
          pagectrl_dsg_elementSettings.Show;
        end;
      end;

      button_dsg_elementBgColor.ButtonColor := Datasource1.DataSet.FieldByName('bgcolor').AsInteger;
      fontDialog_elementBgColor.Color := button_dsg_elementBgColor.ButtonColor;

      button_dsg_elementFgColor.ButtonColor := Datasource1.DataSet.FieldByName('fgcolor').AsInteger;
      fontDialog_elementFgColor.Color := button_dsg_elementFgColor.ButtonColor;

      input_dsg_elementAlignX.ItemIndex := Datasource1.DataSet.FieldByName('ALIGNX').AsInteger;
      input_dsg_elementAlignY.ItemIndex := Datasource1.DataSet.FieldByName('ALIGNY').AsInteger;

      if flag_visualActive = true then
      begin
           // ...
      end;

      panel_element_settings.Show;
    end;
    if flag_isAnyEdit = false then
    begin
      panel_element_settings.Hide;
    end;

    flag_isManageDesignGUI := false;
  end;
end;

procedure Tform_dlg_print.updateHtmlContentUpdateTimerTimer(Sender: TObject);
begin
  updateHtmlContentUpdateTimer.Enabled := false;
  if flag_visualActive = true then
  begin
    ScrollBox.Repaint;
    updateVisualMainView;
  end;
end;


procedure Tform_dlg_print.Datasource1StateChange(Sender: TObject);
begin
  editedDesignerField;
end;

procedure Tform_dlg_print.Datasource1UpdateData(Sender: TObject);
begin
  editedDesignerField;
end;

procedure Tform_dlg_print.DBGrid1CellClick(Column: TColumn);
begin
  editedDesignerField;
  manageDesignerGUI;
end;

procedure Tform_dlg_print.DBGrid1EditingDone(Sender: TObject);
begin
  editedDesignerField;
  manageDesignerGUI;
end;

procedure Tform_dlg_print.DBGrid1EndDrag(Sender, Target: TObject; X, Y: Integer
  );
begin

end;

procedure Tform_dlg_print.DBGrid1Enter(Sender: TObject);
begin
  editedDesignerField;
  manageDesignerGUI;
end;

procedure Tform_dlg_print.DBGrid1KeyPress(Sender: TObject; var Key: char);
begin
  editedDesignerField;
  manageDesignerGUI;
end;

procedure Tform_dlg_print.DBGrid1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  editedDesignerField;
  manageDesignerGUI;
end;

procedure Tform_dlg_print.DBGrid1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  editedDesignerField;
  manageDesignerGUI;
end;

procedure Tform_dlg_print.DBGrid1TitleClick(Column: TColumn);
begin
  editedDesignerField;
  manageDesignerGUI;
end;

procedure Tform_dlg_print.elSettings_dsg_table_bloodvalsContextPopup(
  Sender: TObject; MousePos: TPoint; var Handled: Boolean);
begin

end;

procedure Tform_dlg_print.fontDialog_elementBgColorClose(Sender: TObject);
var
  setDataColor : libdlgform_rgbcolor;
  data_bgColor_RGB : Integer;
begin
  if flag_isChange_elementBgColor = false then
  begin
    flag_isChange_elementBgColor := true;

    setDataColor.red := Red(fontDialog_elementBgColor.Color);
    setDataColor.green := Green(fontDialog_elementBgColor.Color);
    setDataColor.blue := Blue(fontDialog_elementBgColor.Color);
    data_bgColor_RGB := rgb2color(setDataColor);

    beginDesignerEditElement;
    Datasource1.DataSet.FieldByName('bgcolor').AsInteger := data_bgColor_RGB;
    endDesignerEditElement;
    button_dsg_elementBgColor.ButtonColor := data_bgColor_RGB;
    fontDialog_elementBgColor.Color := data_bgColor_RGB;

    flag_isChange_elementBgColor := false;
  end;
end;

procedure Tform_dlg_print.fontDialog_elementFgColorClose(Sender: TObject);
var
  setDataColor : libdlgform_rgbcolor;
  data_fgColor_RGB : Integer;
begin
  if flag_isChange_elementFgColor = false then
  begin
    flag_isChange_elementFgColor := true;

    setDataColor.red := Red(fontDialog_elementFgColor.Color);
    setDataColor.green := Green(fontDialog_elementFgColor.Color);
    setDataColor.blue := Blue(fontDialog_elementFgColor.Color);
    data_fgColor_RGB := rgb2color(setDataColor);

    beginDesignerEditElement;
    Datasource1.DataSet.FieldByName('fgcolor').AsInteger := data_fgColor_RGB;
    endDesignerEditElement;
    button_dsg_elementFgColor.ButtonColor := data_fgColor_RGB;
    fontDialog_elementFgColor.Color := data_fgColor_RGB;

    flag_isChange_elementFgColor := false;
  end;
end;

procedure Tform_dlg_print.input_dsg_elementAlignXChange(Sender: TObject);
begin
  if flag_isChange_elementAlignX = false then
  begin
    flag_isChange_elementAlignX := true;

    beginDesignerEditElement;
    Datasource1.DataSet.FieldByName('ALIGNX').AsInteger := input_dsg_elementAlignX.ItemIndex;
    endDesignerEditElement;

    flag_isChange_elementAlignX := false;
  end;
end;

procedure Tform_dlg_print.input_dsg_elementAlignYChange(Sender: TObject);
begin
  if flag_isChange_elementAlignY = false then
  begin
    flag_isChange_elementAlignY := true;

    beginDesignerEditElement;
    Datasource1.DataSet.FieldByName('ALIGNY').AsInteger := input_dsg_elementAlignY.ItemIndex;
    endDesignerEditElement;

    flag_isChange_elementAlignY := false;
  end;
end;

procedure Tform_dlg_print.Datasource1DataChange(Sender: TObject; Field: TField);
begin
  editedDesignerField;
end;

procedure Tform_dlg_print.button_dsg_elementFontClick(Sender: TObject);
var
  setDataColor : libdlgform_rgbcolor;
  data_fgColor_RGB : Integer;
begin
  FontDialog1.Font.Color := button_dsg_elementFgColor.ButtonColor;
  FontDialog1.Font.Name := Datasource1.DataSet.FieldByName('fontname').AsString;
  FontDialog1.Font.Size := Datasource1.DataSet.FieldByName('fontsize').AsInteger;
  FontDialog1.Font.Style := [];
  if Datasource1.DataSet.FieldByName('FSTYBOLD').AsInteger = 1 then
  begin
       FontDialog1.Font.Style := FontDialog1.Font.Style + [fsBold];
  end;
  if Datasource1.DataSet.FieldByName('FSTYITAL').AsInteger = 1 then
  begin
       FontDialog1.Font.Style := FontDialog1.Font.Style + [fsItalic];
  end;
  if Datasource1.DataSet.FieldByName('FSTYLIMID').AsInteger = 1 then
  begin
       FontDialog1.Font.Style := FontDialog1.Font.Style + [fsStrikeOut];
  end;
  if Datasource1.DataSet.FieldByName('FSTYLIBOT').AsInteger = 1 then
  begin
       FontDialog1.Font.Style := FontDialog1.Font.Style + [fsUnderline];
  end;
  if FontDialog1.Execute then
  begin
    setDataColor.red := Red(FontDialog1.Font.Color);
    setDataColor.green := Green(FontDialog1.Font.Color);
    setDataColor.blue := Blue(FontDialog1.Font.Color);
    data_fgColor_RGB := rgb2color(setDataColor);

    beginDesignerEditElement;
    Datasource1.DataSet.FieldByName('fontname').AsString := FontDialog1.Font.Name;
    Datasource1.DataSet.FieldByName('fontsize').AsInteger := FontDialog1.Font.Size;
    Datasource1.DataSet.FieldByName('fgcolor').AsInteger := data_fgColor_RGB;
    Datasource1.DataSet.FieldByName('FSTYBOLD').AsBoolean := false;
    Datasource1.DataSet.FieldByName('FSTYITAL').AsBoolean := false;
    Datasource1.DataSet.FieldByName('FSTYLIMID').AsBoolean := false;
    Datasource1.DataSet.FieldByName('FSTYLIBOT').AsBoolean := false;
    if fsBold in FontDialog1.Font.Style then
    begin
      Datasource1.DataSet.FieldByName('FSTYBOLD').AsBoolean := true;
    end;
    if fsItalic in FontDialog1.Font.Style then
    begin
      Datasource1.DataSet.FieldByName('FSTYITAL').AsBoolean := true;
    end;
    if fsStrikeOut in FontDialog1.Font.Style then
    begin
      Datasource1.DataSet.FieldByName('FSTYLIMID').AsBoolean := true;
    end;
    if fsUnderline in FontDialog1.Font.Style then
    begin
      Datasource1.DataSet.FieldByName('FSTYLIBOT').AsBoolean := true;
    end;
    endDesignerEditElement;
    button_dsg_elementFgColor.ButtonColor := data_fgColor_RGB;
    fontDialog_elementFgColor.Color := data_fgColor_RGB;

    manageDesignerGUI;
  end;
end;

procedure Tform_dlg_print.button_dsg_elementFgColorColorChanged(Sender: TObject
  );
var
  setDataColor : libdlgform_rgbcolor;
  data_fgColor_RGB : Integer;
begin
  fontDialog_elementFgColor.Color := button_dsg_elementFgColor.ButtonColor;

  setDataColor.red := Red(button_dsg_elementFgColor.ButtonColor);
  setDataColor.green := Green(button_dsg_elementFgColor.ButtonColor);
  setDataColor.blue := Blue(button_dsg_elementFgColor.ButtonColor);
  data_fgColor_RGB := rgb2color(setDataColor);
end;

procedure Tform_dlg_print.button_dsg_elementBgColorColorChanged(Sender: TObject
  );
begin

end;

procedure Tform_dlg_print.button_dsg_elementBgColorClick(Sender: TObject);
begin

end;


function Tform_dlg_print.color2rgb(colr:integer):libdlgform_rgbcolor;
begin
     result.red:=(colr mod 256);
     result.green:= (Round(colr / 256) mod 256);
     result.blue:=Round(Round(colr / 256) / 256);
end;

procedure Tform_dlg_print.button_printClick(Sender: TObject);
begin
  PrintDialog1.Execute;
end;

procedure Tform_dlg_print.button_page_setupClick(Sender: TObject);
begin
  PageSetupDialog1.Title := 'Seiten einstellen';
  PageSetupDialog1.Width := page_pixel_width;
  PageSetupDialog1.Height := page_pixel_height;
  if PageSetupDialog1.Execute then
  begin
    // ...
  end;
end;

procedure Tform_dlg_print.addDesignElement(preType: string; preTypePublic: string; prePosX: Integer; prePosY: Integer; preFontName: string; preFontSize: Integer; preBgColor: Integer; preFgColor: Integer; preContent: string);
var
  isEdit2: boolean;
  orgActiveId: Integer;
  uniqueId: String;
begin
  tools_db_getUniqueId(Datasource1.DataSet, 'id');
  uniqueId := tools_result_string;

  isEdit2 := (Datasource1.DataSet.State in dsEditModes);
  if isEdit2 then
  begin
    Datasource1.DataSet.Post;
    Datasource1.DataSet.Append;
  end;
  if Not isEdit2 then
  begin
    Datasource1.DataSet.Append;
  end;

  Datasource1.DataSet.FieldByName('id').AsString := uniqueId;
  Datasource1.DataSet.FieldByName('type').AsString := preType;
  Datasource1.DataSet.FieldByName('typepublic').AsString := preTypePublic;
  Datasource1.DataSet.FieldByName('posx').AsInteger := prePosX;
  Datasource1.DataSet.FieldByName('posy').AsInteger := prePosY;
  Datasource1.DataSet.FieldByName('fontname').AsString := preFontName;
  Datasource1.DataSet.FieldByName('fontsize').AsInteger := preFontSize;
  Datasource1.DataSet.FieldByName('FSTYBOLD').AsInteger := 0;
  Datasource1.DataSet.FieldByName('FSTYITAL').AsInteger := 0;
  Datasource1.DataSet.FieldByName('FSTYLIMID').AsInteger := 0;
  Datasource1.DataSet.FieldByName('FSTYLIBOT').AsInteger := 0;
  Datasource1.DataSet.FieldByName('bgcolor').AsInteger := preBgColor;
  Datasource1.DataSet.FieldByName('fgcolor').AsInteger := preFgColor;
  Datasource1.DataSet.FieldByName('content').AsString := preContent;
  Datasource1.DataSet.Post;
  Datasource1.DataSet.Last;

  manageDesignerGUI;
end;

procedure Tform_dlg_print.setLastAddedDesignElementData(elementDataIndex: Integer; elementDataValue: String);
var
  fna : String;
begin
  fna := 'DATA';
  fna := fna + IntToStr(elementDataIndex);
  Datasource1.DataSet.Edit;
  Datasource1.DataSet.FieldByName(fna).AsString := elementDataValue;
  Datasource1.DataSet.Post;
end;

procedure Tform_dlg_print.button_dsg_addTextClick(Sender: TObject);
var
  setDataColor : libdlgform_rgbcolor;
  data_fgColor_RGB : Integer;
  data_bgColor_RGB : Integer;
begin
  setDataColor.red := 255;
  setDataColor.green := 255;
  setDataColor.blue := 255;
  data_bgColor_RGB := rgb2color(setDataColor);

  setDataColor.red := 0;
  setDataColor.green := 0;
  setDataColor.blue := 0;
  data_fgColor_RGB := rgb2color(setDataColor);

  addDesignElement('text', 'Text', 10, 10, 'Verdana', 10, data_bgColor_RGB, data_fgColor_RGB, 'Text' );
end;

procedure Tform_dlg_print.button_dsg_addActualPageClick(Sender: TObject);
var
  setDataColor : libdlgform_rgbcolor;
  data_fgColor_RGB : Integer;
  data_bgColor_RGB : Integer;
begin
  setDataColor.red := 255;
  setDataColor.green := 255;
  setDataColor.blue := 255;
  data_bgColor_RGB := rgb2color(setDataColor);

  setDataColor.red := 0;
  setDataColor.green := 0;
  setDataColor.blue := 0;
  data_fgColor_RGB := rgb2color(setDataColor);

  addDesignElement('number_page_index', 'Aktuelle Seite', 10, 10, 'Verdana', 10, data_bgColor_RGB, data_fgColor_RGB, '' );
end;

procedure Tform_dlg_print.button_dsg_addPageCountClick(Sender: TObject);
var
   setDataColor : libdlgform_rgbcolor;
   data_fgColor_RGB : Integer;
   data_bgColor_RGB : Integer;
begin
  setDataColor.red := 255;
  setDataColor.green := 255;
  setDataColor.blue := 255;
  data_bgColor_RGB := rgb2color(setDataColor);

  setDataColor.red := 0;
  setDataColor.green := 0;
  setDataColor.blue := 0;
  data_fgColor_RGB := rgb2color(setDataColor);

  addDesignElement('number_page_count', 'Seitenanzahl', 10, 10, 'Verdana', 10, data_bgColor_RGB, data_fgColor_RGB, '' );
end;

procedure Tform_dlg_print.button_print_setupClick(Sender: TObject);
begin
  PrinterSetupDialog1.Execute;
end;

procedure Tform_dlg_print.FormClose(Sender: TObject;
  var CloseAction: TCloseAction);
begin
  flag_initShow := true;
end;

procedure Tform_dlg_print.FormResize(Sender: TObject);
begin

end;

procedure Tform_dlg_print.FormShow(Sender: TObject);
begin
  if flag_initShow = true then
  begin
    flag_initShow := false;

    flag_visualActive := true;

    content_html.Top := 0 - content_html.Height - 10;
    buffer_image.Top := 0 - buffer_image.Height - 10;

    page_dpi := use_page_dpi;
    page_pixel_width := use_page_pixel_width;
    page_pixel_height := use_page_pixel_height;

    page_rendered := TImage.Create(Application);
    page_rendered.Width := use_page_pixel_width;
    page_rendered.Height := use_page_pixel_height;

    readPageCount;
    if returnCode = 0 then
    begin
      Datasource1.DataSet.Last;
      resizeUpdateMainView;
      adjustMainView;
      updateVisualMainView;
      editedDesignerField;
      manageDesignerGUI;
    end;
  end;
end;

procedure Tform_dlg_print.pagectrl_dsg_elementSettingsChange(Sender: TObject);
begin

end;

procedure Tform_dlg_print.PageSetupDialog1CanClose(Sender: TObject;
  var CanClose: boolean);
begin
  CanClose := true;
end;

procedure Tform_dlg_print.PageSetupDialog1Close(Sender: TObject);
begin

end;

procedure Tform_dlg_print.PageSetupDialog1Show(Sender: TObject);
begin

end;

procedure Tform_dlg_print.Panel1Click(Sender: TObject);
begin

end;

procedure Tform_dlg_print.Panel3Click(Sender: TObject);
begin

end;

procedure Tform_dlg_print.panel_element_listClick(Sender: TObject);
begin

end;

procedure Tform_dlg_print.updateVisualMainView;
var
   newRect : TRect;
begin
  Screen.Cursor := crHourglass;

  content_image.Width := use_page_pixel_width;
  content_image.Height := use_page_pixel_height;

  content_html.Top := (0 - content_html.Height) + 2;
  content_html.Left := (0 - content_html.Width) + 2;

  content_html.Width := data_page_pixel_width;
  content_html.Height := data_page_pixel_height;

  buffer_image.Top := (0 - buffer_image.Height) + 2;
  buffer_image.Left := (0 - buffer_image.Width) + 2;

  buffer_image.Width := data_page_pixel_width;
  buffer_image.Height := data_page_pixel_height;

  updateHtmlContent;
  renderBitmapToImage(page_rendered, content_image, use_scale);

  content_image.Width := use_page_pixel_width;
  content_image.Height := use_page_pixel_height;

  Screen.Cursor := crDefault;
end;


procedure Tform_dlg_print.resizeUpdateMainView;
var
   zoomTest: Integer;
begin
  if view_zoom.ItemIndex = 0 then
  begin
    use_scale := 1.0;

    if data_page_pixel_height > data_page_pixel_width then
    begin
      zoomTest := Round(data_page_pixel_height * use_scale);
      while zoomTest > ScrollBox.Height - 70 do
      begin
        use_scale := use_scale - 0.01;
        zoomTest := Round(data_page_pixel_height * use_scale);
      end;
      while zoomTest < ScrollBox.Height - 70 do
      begin
        use_scale := use_scale + 0.01;
        zoomTest := Round(data_page_pixel_height * use_scale);
      end;
    end;

    if Not data_page_pixel_height > data_page_pixel_width then
    begin
      zoomTest := Round(data_page_pixel_width * use_scale);
      while zoomTest > ScrollBox.Width - 90 do
      begin
        use_scale := use_scale - 0.01;
        zoomTest := Round(data_page_pixel_width * use_scale);
      end;
      while zoomTest < ScrollBox.Width - 90 do
      begin
        use_scale := use_scale + 0.01;
        zoomTest := Round(data_page_pixel_width * use_scale);
      end;
    end;

  end;

  use_page_dpi := Round(data_page_dpi * use_scale);
  use_page_pixel_width := Round(data_page_pixel_width * use_scale);
  use_page_pixel_height := Round(data_page_pixel_height * use_scale);

  content_background2.Width := use_page_pixel_width;
  content_background2.Height := use_page_pixel_height;

  if view_zoom.ItemIndex = 0 then
  begin
       adjustMainView;
  end;

  updateVisualMainView;
end;

procedure Tform_dlg_print.adjustMainView;
begin
  content_background1.Width := use_page_pixel_width + 50;
  content_background1.Height := use_page_pixel_height + 50;
  content_background1.Left := floor((ScrollBox.Width / 2) - (content_background1.Width / 2));

  content_background2.Top := 30;
  content_background2.Left := 7 + floor((content_background1.Width / 2) - (content_background2.Width / 2));

  content_image.Top := content_background2.Top - 15;
  content_image.Left := content_background2.Left - 15;
end;

procedure Tform_dlg_print.renderBitmapToImage(bitBmp: TImage; pBox: TImage; Scale: double);
var
  rect_target: TRect;
  TTop, TLeft,
  WindowTop, WindowLeft: Integer;
  R: TRect;
  R2: TRect;
  SourceRect: TRect;
  Scratch: TBitmap;
const
  SCRATCH_WIDTH = 80;
  SCRATCH_HEIGHT = 60;
begin
  SourceRect.Left := 0;
  SourceRect.Top := 0;
  SourceRect.Right := bitBmp.Canvas.Width;
  SourceRect.Bottom := bitBmp.Canvas.Height;

  pBox.Width := bitBmp.Canvas.Width;
  pBox.Height := bitBmp.Canvas.Height;

  Scratch := TBitmap.Create;
  Scratch.Width := SCRATCH_WIDTH;
  Scratch.Height := SCRATCH_HEIGHT;

  R2.Left := 0;
  R2.Top := 0;
  R2.Right := SCRATCH_WIDTH;
  R2.Bottom := SCRATCH_HEIGHT;

  pBox.Canvas.Brush.Color := clWhite;
  pBox.Canvas.FillRect(pBox.Canvas.ClipRect);
  WindowTop := SourceRect.Top;
  TTop := 0;
  while WindowTop < SourceRect.Bottom do begin
    WindowLeft := SourceRect.Left;
    TLeft := 0;
    while WindowLeft < SourceRect.Right do begin
      R.Left := WindowLeft;
      R.Top := WindowTop;
      R.Right := R.Left + SCRATCH_WIDTH + 1;
      R.Bottom := R.Top + SCRATCH_HEIGHT + 1;
      Scratch.Canvas.CopyRect(R2, bitBmp.Canvas, R);

      R.Left := pBox.Canvas.ClipRect.Left + round(TLeft * Scale);
      R.Top := pBox.Canvas.ClipRect.Top + round(TTop * Scale);
      R.Right := R.Left + round(SCRATCH_WIDTH * Scale) + 1;
      R.Bottom := R.Top + round(SCRATCH_HEIGHT * Scale) + 1;

      pBox.Canvas.StretchDraw(R, Scratch);

      inc(WindowLeft, SCRATCH_WIDTH);
      inc(TLeft, SCRATCH_WIDTH);
    end;
    inc(WindowTop, SCRATCH_HEIGHT);
    inc(TTop, SCRATCH_HEIGHT);
  end;

  Scratch.Free;


end;

procedure Tform_dlg_print.renderHtmlToImage(htmlPanel: TIpHtmlPanel; pBox: TImage; Scale: double);
var
  rect_target: TRect;
  TTop, TLeft,
  WindowTop, WindowLeft: Integer;
  R: TRect;
  SourceRect: TRect;
  Scratch: TBitmap;
  HTML : TIpHtml;
const
  SCRATCH_WIDTH = 80;
  SCRATCH_HEIGHT = 60;
begin
  HTML := htmlPanel.MasterFrame.Html;

  pBox.Width := htmlPanel.Width;
  pBox.Height := htmlPanel.Height;


  Scratch := TBitmap.Create;
  Scratch.Width := SCRATCH_WIDTH;
  Scratch.Height := SCRATCH_HEIGHT;

  SourceRect.Left := 0;
  SourceRect.Top := 0;
  SourceRect.Right := 0;
  SourceRect.Bottom := 0;

  SourceRect.Right := htmlPanel.Width;
  SourceRect.Bottom := htmlPanel.Height;

  pBox.Canvas.Brush.Color := clWhite;
  pBox.Canvas.FillRect(pBox.Canvas.ClipRect);
  WindowTop := SourceRect.Top;
  TTop := 0;
  while WindowTop < SourceRect.Bottom do begin
    WindowLeft := SourceRect.Left;
    TLeft := 0;
    while WindowLeft < SourceRect.Right do begin
      R.Left := WindowLeft;
      R.Top := WindowTop;
      R.Right := R.Left + SCRATCH_WIDTH + 1;
      R.Bottom := R.Top + SCRATCH_HEIGHT + 1;
      HTML.Render(Scratch.Canvas, R, False, Point(0, 0));

      R.Left := pBox.Canvas.ClipRect.Left + round(TLeft * Scale);
      R.Top := pBox.Canvas.ClipRect.Top + round(TTop * Scale);
      R.Right := R.Left + round(SCRATCH_WIDTH * Scale) + 1;
      R.Bottom := R.Top + round(SCRATCH_HEIGHT * Scale) + 1;

      pBox.Canvas.StretchDraw(R, Scratch);

      inc(WindowLeft, SCRATCH_WIDTH);
      inc(TLeft, SCRATCH_WIDTH);
    end;
    inc(WindowTop, SCRATCH_HEIGHT);
    inc(TTop, SCRATCH_HEIGHT);
  end;

  Scratch.Free;

end;

procedure Tform_dlg_print.resizeUpdateTimerStopTimer(Sender: TObject);
begin

end;

procedure Tform_dlg_print.resizeUpdateTimerTimer(Sender: TObject);
begin
  resizeUpdateTimer.Enabled := false;
  if flag_visualActive = true then
  begin
       resizeUpdateMainView;
  end;
end;

procedure Tform_dlg_print.editedDesignerField;
begin
  if updateHtmlContentUpdateTimer.Enabled = false then
  begin
    updateHtmlContentUpdateTimer.Enabled := true;
  end;
end;

procedure Tform_dlg_print.ScrollBoxResize(Sender: TObject);
begin
  if resizeUpdateTimer.Enabled = false then
  begin
    resizeUpdateTimer.Enabled := true;
  end;
  adjustMainView;
end;

procedure Tform_dlg_print.updateHtmlContent;
var
  flag_run: boolean;

  newRect: TRect;

  elementData_type: String;
  elementData_pageCount: Integer;
  elementData_posX: Integer;
  elementData_posY: Integer;
  elementData_width: Integer;
  elementData_height: Integer;
  elementData_fontSize: Integer;
  elementData_defaultStyle: String;
  elementData_content: String;
  elementData_alignX: Integer;
  elementData_alignY: Integer;
  setColorRGBdata: libdlgform_rgbcolor;

  resultHtml: String;

  zz: Integer;

  orgActiveId: Integer;

  stringTable: tool_stringTable;

  tIRow       : Integer;
  tICol       : Integer;
  tRows       : Integer;
  tCols       : Integer;
  tColWidth   : array[0..500] of string;
begin
  tools_db_getActive(Datasource1.DataSet, 'id');
  orgActiveId := tools_result_integer;

  zz := 0;

  newRect.Top := 0;
  newRect.Left := 0;
  newRect.Right := data_page_pixel_width;
  newRect.Bottom := data_page_pixel_height;

  page_rendered.Width := data_page_pixel_width;
  page_rendered.Height := data_page_pixel_height;

  page_rendered.Canvas.Brush.Color := clWhite;
  page_rendered.Canvas.FillRect(page_rendered.Canvas.ClipRect);

  page_rendered.Canvas.Pen.Style := psDot;
  setColorRGBdata.red := 175;
  setColorRGBdata.green := 175;
  setColorRGBdata.blue := 175;
  page_rendered.Canvas.Pen.Color := rgb2color(setColorRGBdata);
  page_rendered.Canvas.Pen.Width := 8;

  page_rendered.Canvas.Rectangle( data_page_pixel_margin_left, data_page_pixel_margin_top, data_page_pixel_width - (data_page_pixel_margin_right), data_page_pixel_height - (data_page_pixel_margin_bottom) );

  page_rendered.Canvas.Pen.Style := psSolid;
  setColorRGBdata.red := 0;
  setColorRGBdata.green := 0;
  setColorRGBdata.blue := 0;
  page_rendered.Canvas.Pen.Color := rgb2color(setColorRGBdata);
  page_rendered.Canvas.Pen.Width := 0;

  page_rendered.Canvas.Brush.Color := clWhite;
  page_rendered.Canvas.FillRect( Rect(data_page_pixel_margin_left, data_page_pixel_margin_top, data_page_pixel_width - (data_page_pixel_margin_right), data_page_pixel_height - (data_page_pixel_margin_bottom)) );
  page_rendered.Canvas.Brush.Color := clBlack;

  if Datasource1.DataSet.Active = true then
  begin
    if Datasource1.DataSet.RecordCount > 0 then
    begin
      Datasource1.DataSet.First;
      flag_run := true;
      while flag_run = true do
      begin
        if Datasource1.DataSet.EOF then
        begin
             flag_run := false;
        end;
        if flag_run = true then
        begin
             elementData_type := Datasource1.DataSet.FieldByName('TYPE').AsString;
             elementData_posX := round( ((data_page_pixel_width-data_page_pixel_margin_left-(data_page_pixel_margin_right)) / 100) * Datasource1.DataSet.FieldByName('POSX').AsInteger );
             elementData_posY := round( ((data_page_pixel_height-data_page_pixel_margin_top-(data_page_pixel_margin_bottom)) / 100) * Datasource1.DataSet.FieldByName('POSY').AsInteger );
             elementData_width := 0;
             elementData_height := 0;
             elementData_alignX := Datasource1.DataSet.FieldByName('ALIGNX').AsInteger;
             elementData_alignY := Datasource1.DataSet.FieldByName('ALIGNY').AsInteger;
             elementData_content := Datasource1.DataSet.FieldByName('CONTENT').AsString;
             elementData_fontSize := Datasource1.DataSet.FieldByName('FONTSIZE').AsInteger * 5;

             if elementData_type = 'number_page_index' then
             begin
               elementData_content := IntToStr(page_activePage + 1);
             end;

             if elementData_type = 'number_page_count' then
             begin
               elementData_content := IntToStr(page_count + 1);
             end;

             page_rendered.Canvas.Brush.Color := Datasource1.DataSet.FieldByName('BGCOLOR').AsInteger;
             page_rendered.Canvas.Font.Color := Datasource1.DataSet.FieldByName('FGCOLOR').AsInteger;
             page_rendered.Canvas.Font.Name := Datasource1.DataSet.FieldByName('FONTNAME').AsString;
             page_rendered.Canvas.Font.Size := Datasource1.DataSet.FieldByName('FONTSIZE').AsInteger * 5;
             page_rendered.Canvas.Font.Style := [];
             if Datasource1.DataSet.FieldByName('FSTYBOLD').AsInteger = 1 then
             begin
                  page_rendered.Canvas.Font.Style := FontDialog1.Font.Style + [fsBold];
             end;
             if Datasource1.DataSet.FieldByName('FSTYITAL').AsInteger = 1 then
             begin
                  page_rendered.Canvas.Font.Style := FontDialog1.Font.Style + [fsItalic];
             end;
             if Datasource1.DataSet.FieldByName('FSTYLIMID').AsInteger = 1 then
             begin
                  page_rendered.Canvas.Font.Style := FontDialog1.Font.Style + [fsStrikeOut];
             end;
             if Datasource1.DataSet.FieldByName('FSTYLIBOT').AsInteger = 1 then
             begin
                  page_rendered.Canvas.Font.Style := FontDialog1.Font.Style + [fsUnderline];
             end;

             if elementData_content = '' then
             begin
               elementData_content := data_designElementHandler(1, elementData_type, page_activePage, Datasource1);

               if elementData_content = '' then
               begin
                 elementData_content := data_designElementHandler(2, elementData_type, page_activePage, Datasource1);

                 stringTable := tool_stringTable.Create;
                 stringTable.loadFromString(elementData_content);
                 stringTable.canvas_draw(page_rendered.Canvas, 0, 0, 1000, 1000);

                 Memo1.Append(  stringTable.getCellAsString(0, 0)  );

                 stringTable.free;

                 elementData_content := '';
               end;
             end;

             if Not (elementData_content = '') then
             begin
               elementData_width := page_rendered.Canvas.TextWidth(elementData_content);
               elementData_height := page_rendered.Canvas.TextHeight(elementData_content);
             end;

             if elementData_alignX = 1 then
             begin
                  elementData_posX := elementData_posX - round( elementData_width / 2.0 );
             end;

             if elementData_alignX = 2 then
             begin
                  elementData_posX := elementData_posX - elementData_width;
             end;

             if elementData_alignX = 3 then
             begin
                  elementData_posX := elementData_posX - round( (elementData_width / 100) * Datasource1.DataSet.FieldByName('POSX').AsInteger );
             end;

             if elementData_alignY = 1 then
             begin
                  elementData_posY := elementData_posY - round( elementData_height / 2.0 );
             end;

             if elementData_alignY = 2 then
             begin
                  elementData_posY := elementData_posY - elementData_height;
             end;

             if elementData_alignY = 3 then
             begin
                  elementData_posY := elementData_posY - round( (elementData_height / 100) * Datasource1.DataSet.FieldByName('POSY').AsInteger );
             end;

             elementData_posX := elementData_posX + data_page_pixel_margin_left;
             elementData_posY := elementData_posY + data_page_pixel_margin_top;

             if Not (elementData_content = '') then
             begin
                  page_rendered.Canvas.TextOut( elementData_posX, elementData_posY, elementData_content );
             end;

             if elementData_content = '' then
             begin

             end;

             zz := zz + 1;

             Datasource1.DataSet.Next;
        end;
      end;

    end;
  end;

  page_rendered.Repaint;

  tools_db_setActive(Datasource1.DataSet, 'id', orgActiveId);
end;

end.

